# swagger-java-client

Travel Search API
- API version: 1.0.0
  - Build date: 2023-05-15T08:22:21.823424346Z[GMT]

API for perform travel booking


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AirSearchServiceApi;

import java.io.File;
import java.util.*;

public class AirSearchServiceApiExample {

    public static void main(String[] args) {
        
        AirSearchServiceApi apiInstance = new AirSearchServiceApi();
        AirCriteria body = new AirCriteria(); // AirCriteria | 
        String sessionId = "sessionId_example"; // String | Session ID
        String conversationId = "conversationId_example"; // String | Conversation ID
        String X_API_KEY = "X_API_KEY_example"; // String | API access key
        try {
            ResponsePackAir result = apiInstance.performAirSearchRq(body, sessionId, conversationId, X_API_KEY);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AirSearchServiceApi#performAirSearchRq");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AirSearchServiceApi;

import java.io.File;
import java.util.*;

public class AirSearchServiceApiExample {

    public static void main(String[] args) {
        
        AirSearchServiceApi apiInstance = new AirSearchServiceApi();
        AirFareRuleCriteria body = new AirFareRuleCriteria(); // AirFareRuleCriteria | 
        String sessionId = "sessionId_example"; // String | Session ID
        String conversationId = "conversationId_example"; // String | Conversation ID
        String X_API_KEY = "X_API_KEY_example"; // String | API access key
        try {
            ResponsePackAirFareRuleResult result = apiInstance.performFareRuleSearchRq(body, sessionId, conversationId, X_API_KEY);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AirSearchServiceApi#performFareRuleSearchRq");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AirSearchServiceApi;

import java.io.File;
import java.util.*;

public class AirSearchServiceApiExample {

    public static void main(String[] args) {
        
        AirSearchServiceApi apiInstance = new AirSearchServiceApi();
        MoreFaresCriteria body = new MoreFaresCriteria(); // MoreFaresCriteria | 
        String sessionId = "sessionId_example"; // String | Session ID
        String conversationId = "conversationId_example"; // String | Conversation ID
        String X_API_KEY = "X_API_KEY_example"; // String | API access key
        try {
            ResponsePackAir result = apiInstance.performMoreFaresSearchRq(body, sessionId, conversationId, X_API_KEY);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AirSearchServiceApi#performMoreFaresSearchRq");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://api.travlinq.provesio.com/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AirSearchServiceApi* | [**performAirSearchRq**](docs/AirSearchServiceApi.md#performAirSearchRq) | **POST** /api/v1/flight/search | Air search
*AirSearchServiceApi* | [**performFareRuleSearchRq**](docs/AirSearchServiceApi.md#performFareRuleSearchRq) | **POST** /api/v1/flight/fare-rule-search | Air fare rules
*AirSearchServiceApi* | [**performMoreFaresSearchRq**](docs/AirSearchServiceApi.md#performMoreFaresSearchRq) | **POST** /api/v1/flight/more-fares | Air more fare search
*AuthServiceApi* | [**loginUser**](docs/AuthServiceApi.md#loginUser) | **POST** /api/v1/auth/login | Login user
*AuthServiceApi* | [**logoutUser**](docs/AuthServiceApi.md#logoutUser) | **POST** /api/v1/auth/logout | Logout use
*CarSearchServiceApi* | [**getCancellationPolicy**](docs/CarSearchServiceApi.md#getCancellationPolicy) | **POST** /api/v1/car/cancellation-policy | Car Book
*CarSearchServiceApi* | [**performCarSearch**](docs/CarSearchServiceApi.md#performCarSearch) | **POST** /api/v1/car/search | Car search
*HotelSearchServiceApi* | [**performCancellationPoliciesRq**](docs/HotelSearchServiceApi.md#performCancellationPoliciesRq) | **POST** /api/v1/hotel/cancellation-policy | Get Hotel Cancellation Policies
*HotelSearchServiceApi* | [**performHotelDetailSearchRq**](docs/HotelSearchServiceApi.md#performHotelDetailSearchRq) | **POST** /api/v1/hotel/details | Hotel Detail Search
*HotelSearchServiceApi* | [**performHotelSearchRq**](docs/HotelSearchServiceApi.md#performHotelSearchRq) | **POST** /api/v1/hotel/search | Hotel Search
*HotelSearchServiceApi* | [**performMoreRoomRq**](docs/HotelSearchServiceApi.md#performMoreRoomRq) | **POST** /api/v1/hotel/more-rooms | Hotel Search Get More Rooms
*ReservationServiceApi* | [**getAirCancellationCharges**](docs/ReservationServiceApi.md#getAirCancellationCharges) | **POST** /api/v1/reservation/flight-cancellation-charge | Flight cancellation charges
*ReservationServiceApi* | [**performAirBooking**](docs/ReservationServiceApi.md#performAirBooking) | **POST** /api/v1/reservation/flight-book | Flight book
*ReservationServiceApi* | [**performAirBookingRetrieve**](docs/ReservationServiceApi.md#performAirBookingRetrieve) | **POST** /api/v1/reservation/flight-book-retrieve | Flight Booking Retrieve
*ReservationServiceApi* | [**performAirCancel**](docs/ReservationServiceApi.md#performAirCancel) | **POST** /api/v1/reservation/flight-cancel | Flight cancel
*ReservationServiceApi* | [**performAirPassivePnrBooking**](docs/ReservationServiceApi.md#performAirPassivePnrBooking) | **POST** /api/v1/reservation/flight-passive-pnr | Flight Passive PNR Book
*ReservationServiceApi* | [**performAirProvisionalBooking**](docs/ReservationServiceApi.md#performAirProvisionalBooking) | **POST** /api/v1/reservation/flight-prov-book | Flight provisional book
*ReservationServiceApi* | [**performAirReInitiateBooking**](docs/ReservationServiceApi.md#performAirReInitiateBooking) | **POST** /api/v1/reservation/flight-re-initiate-booking | Flight Re-Initiate Booking
*ReservationServiceApi* | [**performAncillaryBookRequest**](docs/ReservationServiceApi.md#performAncillaryBookRequest) | **POST** /api/v1/reservation/ancillary-book | Ancillary Book
*ReservationServiceApi* | [**performAncillaryDirectBookRequest**](docs/ReservationServiceApi.md#performAncillaryDirectBookRequest) | **POST** /api/v1/reservation/ancillary-direct-book | Ancillary Direct Book
*ReservationServiceApi* | [**performAncillaryProBookRequest**](docs/ReservationServiceApi.md#performAncillaryProBookRequest) | **POST** /api/v1/reservation/ancillary-prov-book | Ancillary Prov Book
*ReservationServiceApi* | [**performAncillarySearchRequest**](docs/ReservationServiceApi.md#performAncillarySearchRequest) | **POST** /api/v1/reservation/ancillary-search | Ancillary search
*ReservationServiceApi* | [**performCarAddExtras**](docs/ReservationServiceApi.md#performCarAddExtras) | **POST** /api/v1/reservation/car-add-extra | Car Add Extras
*ReservationServiceApi* | [**performCarBook**](docs/ReservationServiceApi.md#performCarBook) | **POST** /api/v1/reservation/car-book | Car Book
*ReservationServiceApi* | [**performCarBookingCancellation**](docs/ReservationServiceApi.md#performCarBookingCancellation) | **POST** /api/v1/reservation/car-cancel | Car Booking Cancellation
*ReservationServiceApi* | [**performCarBookingRetrieve**](docs/ReservationServiceApi.md#performCarBookingRetrieve) | **POST** /api/v1/reservation/car-book-retrieve | Car Booking Retrieve
*ReservationServiceApi* | [**performCarPrebook**](docs/ReservationServiceApi.md#performCarPrebook) | **POST** /api/v1/reservation/car-pre-book | Car Pre Book
*ReservationServiceApi* | [**performHotelBooking**](docs/ReservationServiceApi.md#performHotelBooking) | **POST** /api/v1/reservation/hotel-book | Hotel Book
*ReservationServiceApi* | [**performHotelBookingRetrieve**](docs/ReservationServiceApi.md#performHotelBookingRetrieve) | **POST** /api/v1/reservation/hotel-book-retrieve | Hotel Booking Retrieve
*ReservationServiceApi* | [**performHotelCancel**](docs/ReservationServiceApi.md#performHotelCancel) | **POST** /api/v1/reservation/hotel-cancel | Hotel Book Cancel
*ReservationServiceApi* | [**performHotelPrebook**](docs/ReservationServiceApi.md#performHotelPrebook) | **POST** /api/v1/reservation/hotel-pre-book | Hotel Pre Book
*ReservationServiceApi* | [**performReissueBook**](docs/ReservationServiceApi.md#performReissueBook) | **POST** /api/v1/reservation/flight-reissue-book | Flight Reissue Book
*ReservationServiceApi* | [**performReissueDifferentialFareSearch**](docs/ReservationServiceApi.md#performReissueDifferentialFareSearch) | **POST** /api/v1/reservation/flight-reissue-differential-fare-search | Flight Reissue Differential Fare Search
*ReservationServiceApi* | [**performReissueProvBook**](docs/ReservationServiceApi.md#performReissueProvBook) | **POST** /api/v1/reservation/flight-reissue-prov-book | Flight Reissue Prov Book
*ReservationServiceApi* | [**performReissueSearch**](docs/ReservationServiceApi.md#performReissueSearch) | **POST** /api/v1/reservation/flight-reissue-search | Flight Reissue Search

## Documentation for Models

 - [AdditionalProperty](docs/AdditionalProperty.md)
 - [Address](docs/Address.md)
 - [Air](docs/Air.md)
 - [AirAncillary](docs/AirAncillary.md)
 - [AirAncillarySearchResponse](docs/AirAncillarySearchResponse.md)
 - [AirBookCriteria](docs/AirBookCriteria.md)
 - [AirBooking](docs/AirBooking.md)
 - [AirBookingRetrievalCriteria](docs/AirBookingRetrievalCriteria.md)
 - [AirCancel](docs/AirCancel.md)
 - [AirCancellationCharges](docs/AirCancellationCharges.md)
 - [AirCancellationCriteria](docs/AirCancellationCriteria.md)
 - [AirCriteria](docs/AirCriteria.md)
 - [AirDetail](docs/AirDetail.md)
 - [AirFareRuleCriteria](docs/AirFareRuleCriteria.md)
 - [AirFareRuleResult](docs/AirFareRuleResult.md)
 - [AirIdentityDocument](docs/AirIdentityDocument.md)
 - [AirInformationRow](docs/AirInformationRow.md)
 - [AirPassenger](docs/AirPassenger.md)
 - [AirPassivePnrBookCriteria](docs/AirPassivePnrBookCriteria.md)
 - [AirPaymentDetails](docs/AirPaymentDetails.md)
 - [AirProvBookCriteria](docs/AirProvBookCriteria.md)
 - [AirRow](docs/AirRow.md)
 - [AirRowSeat](docs/AirRowSeat.md)
 - [AirSeatCharacteristic](docs/AirSeatCharacteristic.md)
 - [AirSsr](docs/AirSsr.md)
 - [AirTicketDocument](docs/AirTicketDocument.md)
 - [AirlineLocatorInfo](docs/AirlineLocatorInfo.md)
 - [AirlinePreferences](docs/AirlinePreferences.md)
 - [AirlineRequests](docs/AirlineRequests.md)
 - [AmountInfo](docs/AmountInfo.md)
 - [Ancillary](docs/Ancillary.md)
 - [AncillaryBookCriteria](docs/AncillaryBookCriteria.md)
 - [AncillaryBooking](docs/AncillaryBooking.md)
 - [AncillaryFare](docs/AncillaryFare.md)
 - [AncillaryProvBookCriteria](docs/AncillaryProvBookCriteria.md)
 - [AncillaryResult](docs/AncillaryResult.md)
 - [AncillarySearchCriteria](docs/AncillarySearchCriteria.md)
 - [ApiErrorDetails](docs/ApiErrorDetails.md)
 - [ApplicableFeeRemark](docs/ApplicableFeeRemark.md)
 - [ArrivalTransfer](docs/ArrivalTransfer.md)
 - [AsyncFetch](docs/AsyncFetch.md)
 - [Baggage](docs/Baggage.md)
 - [BaggagePreference](docs/BaggagePreference.md)
 - [BaseHotelCriteria](docs/BaseHotelCriteria.md)
 - [BookingCancel](docs/BookingCancel.md)
 - [BookingCancelCriteria](docs/BookingCancelCriteria.md)
 - [BookingCancellationCriteria](docs/BookingCancellationCriteria.md)
 - [BookingCancellationResponse](docs/BookingCancellationResponse.md)
 - [BookingRoom](docs/BookingRoom.md)
 - [Branding](docs/Branding.md)
 - [Cabin](docs/Cabin.md)
 - [CancellationCharge](docs/CancellationCharge.md)
 - [CancellationPolicy](docs/CancellationPolicy.md)
 - [Car](docs/Car.md)
 - [CarBooking](docs/CarBooking.md)
 - [CarBookingCriteria](docs/CarBookingCriteria.md)
 - [CarBookingRetrieveCriteria](docs/CarBookingRetrieveCriteria.md)
 - [CarCancellationPolicy](docs/CarCancellationPolicy.md)
 - [CarCancellationPolicyCriteria](docs/CarCancellationPolicyCriteria.md)
 - [CarCancellationPolicyResponse](docs/CarCancellationPolicyResponse.md)
 - [CarContact](docs/CarContact.md)
 - [CarContactReservationServiceApi](docs/CarContactReservationServiceApi.md)
 - [CarIdentityDocument](docs/CarIdentityDocument.md)
 - [CarPassenger](docs/CarPassenger.md)
 - [CarPassengerCriteria](docs/CarPassengerCriteria.md)
 - [CarPassengerReservationServiceApi](docs/CarPassengerReservationServiceApi.md)
 - [CarPreBookCriteria](docs/CarPreBookCriteria.md)
 - [CarSearchCriteria](docs/CarSearchCriteria.md)
 - [CheckedInBaggage](docs/CheckedInBaggage.md)
 - [ClientInfo](docs/ClientInfo.md)
 - [CommonData](docs/CommonData.md)
 - [CommonDataAirSearchApi](docs/CommonDataAirSearchApi.md)
 - [CommonDataAuthServiceApi](docs/CommonDataAuthServiceApi.md)
 - [CommonDataHotelSearchApi](docs/CommonDataHotelSearchApi.md)
 - [CommonDataReservationServiceApi](docs/CommonDataReservationServiceApi.md)
 - [ConnectionCodes](docs/ConnectionCodes.md)
 - [Contact](docs/Contact.md)
 - [ContactProvide](docs/ContactProvide.md)
 - [CustomerAdditionalFareInfo](docs/CustomerAdditionalFareInfo.md)
 - [CustomerAdditionalFareInfoAirSearchApi](docs/CustomerAdditionalFareInfoAirSearchApi.md)
 - [CustomerAdditionalFareInfoHotelSearchApi](docs/CustomerAdditionalFareInfoHotelSearchApi.md)
 - [CustomerAdditionalFareInfoReservationServiceApi](docs/CustomerAdditionalFareInfoReservationServiceApi.md)
 - [CustomerInfo](docs/CustomerInfo.md)
 - [Deck](docs/Deck.md)
 - [Distance](docs/Distance.md)
 - [DropOffLocationDetail](docs/DropOffLocationDetail.md)
 - [EssentialNote](docs/EssentialNote.md)
 - [Facility](docs/Facility.md)
 - [Fare](docs/Fare.md)
 - [FareBreakDown](docs/FareBreakDown.md)
 - [FareCode](docs/FareCode.md)
 - [FarePreference](docs/FarePreference.md)
 - [FareReference](docs/FareReference.md)
 - [FareReservationServiceApi](docs/FareReservationServiceApi.md)
 - [FareRule](docs/FareRule.md)
 - [FareRuleBaggageAllowance](docs/FareRuleBaggageAllowance.md)
 - [FareType](docs/FareType.md)
 - [Filters](docs/Filters.md)
 - [FinancialInfo](docs/FinancialInfo.md)
 - [Flight](docs/Flight.md)
 - [FlightInfo](docs/FlightInfo.md)
 - [FlightPassiveSegment](docs/FlightPassiveSegment.md)
 - [FlightPreference](docs/FlightPreference.md)
 - [FlightSegment](docs/FlightSegment.md)
 - [FuelInfo](docs/FuelInfo.md)
 - [Hotel](docs/Hotel.md)
 - [HotelBooking](docs/HotelBooking.md)
 - [HotelBookingCriteria](docs/HotelBookingCriteria.md)
 - [HotelBookingRetrieveCriteria](docs/HotelBookingRetrieveCriteria.md)
 - [HotelCancellationPolicyCriteria](docs/HotelCancellationPolicyCriteria.md)
 - [HotelDetails](docs/HotelDetails.md)
 - [HotelFacility](docs/HotelFacility.md)
 - [HotelHotelSearchApi](docs/HotelHotelSearchApi.md)
 - [HotelIdentityDocument](docs/HotelIdentityDocument.md)
 - [HotelPassenger](docs/HotelPassenger.md)
 - [HotelPassiveSegment](docs/HotelPassiveSegment.md)
 - [HotelPaymentDetails](docs/HotelPaymentDetails.md)
 - [HotelPenalty](docs/HotelPenalty.md)
 - [HotelPreBookCriteria](docs/HotelPreBookCriteria.md)
 - [HotelPrebook](docs/HotelPrebook.md)
 - [HotelRequests](docs/HotelRequests.md)
 - [HotelSearchCriteria](docs/HotelSearchCriteria.md)
 - [HotelSsr](docs/HotelSsr.md)
 - [Image](docs/Image.md)
 - [Journey](docs/Journey.md)
 - [LoginResponse](docs/LoginResponse.md)
 - [LoyaltyProgramAccount](docs/LoyaltyProgramAccount.md)
 - [LoyaltyProgrammeAccount](docs/LoyaltyProgrammeAccount.md)
 - [MandatoryBookData](docs/MandatoryBookData.md)
 - [Meals](docs/Meals.md)
 - [Meta](docs/Meta.md)
 - [MetaData](docs/MetaData.md)
 - [MiniFareRule](docs/MiniFareRule.md)
 - [MoreFaresCriteria](docs/MoreFaresCriteria.md)
 - [NearbyArea](docs/NearbyArea.md)
 - [NoShowPolicyDetail](docs/NoShowPolicyDetail.md)
 - [NoShowPolicyDetailHotelSearchApi](docs/NoShowPolicyDetailHotelSearchApi.md)
 - [Offer](docs/Offer.md)
 - [Offers](docs/Offers.md)
 - [Osi](docs/Osi.md)
 - [OtherAncillaries](docs/OtherAncillaries.md)
 - [Passenger](docs/Passenger.md)
 - [PassengerInfo](docs/PassengerInfo.md)
 - [PassengerMandatoryData](docs/PassengerMandatoryData.md)
 - [PassivePnrBook](docs/PassivePnrBook.md)
 - [PaxRate](docs/PaxRate.md)
 - [PaxRateReservationServiceApi](docs/PaxRateReservationServiceApi.md)
 - [Payment](docs/Payment.md)
 - [PaymentDetails](docs/PaymentDetails.md)
 - [PaymentHotelSearchApi](docs/PaymentHotelSearchApi.md)
 - [PaymentReservationServiceApi](docs/PaymentReservationServiceApi.md)
 - [Penalty](docs/Penalty.md)
 - [PenaltyInfo](docs/PenaltyInfo.md)
 - [Phone](docs/Phone.md)
 - [PickUpLocationDetail](docs/PickUpLocationDetail.md)
 - [PnrDetails](docs/PnrDetails.md)
 - [PolicyDetail](docs/PolicyDetail.md)
 - [PolicyDetailHotelSearchApi](docs/PolicyDetailHotelSearchApi.md)
 - [PostalAddress](docs/PostalAddress.md)
 - [Preference](docs/Preference.md)
 - [PricedCoverage](docs/PricedCoverage.md)
 - [PropertyInfo](docs/PropertyInfo.md)
 - [Rate](docs/Rate.md)
 - [RatePlan](docs/RatePlan.md)
 - [ResponsePackAir](docs/ResponsePackAir.md)
 - [ResponsePackAirAncillarySearchResponse](docs/ResponsePackAirAncillarySearchResponse.md)
 - [ResponsePackAirBooking](docs/ResponsePackAirBooking.md)
 - [ResponsePackAirCancel](docs/ResponsePackAirCancel.md)
 - [ResponsePackAirCancellationCharges](docs/ResponsePackAirCancellationCharges.md)
 - [ResponsePackAirFareRuleResult](docs/ResponsePackAirFareRuleResult.md)
 - [ResponsePackAirReservationServiceApi](docs/ResponsePackAirReservationServiceApi.md)
 - [ResponsePackAncillaryBooking](docs/ResponsePackAncillaryBooking.md)
 - [ResponsePackAncillaryResult](docs/ResponsePackAncillaryResult.md)
 - [ResponsePackBookingCancel](docs/ResponsePackBookingCancel.md)
 - [ResponsePackBookingCancellationResponse](docs/ResponsePackBookingCancellationResponse.md)
 - [ResponsePackCancellationPolicy](docs/ResponsePackCancellationPolicy.md)
 - [ResponsePackCar](docs/ResponsePackCar.md)
 - [ResponsePackCarBooking](docs/ResponsePackCarBooking.md)
 - [ResponsePackCarCancellationPolicyResponse](docs/ResponsePackCarCancellationPolicyResponse.md)
 - [ResponsePackCarReservationServiceApi](docs/ResponsePackCarReservationServiceApi.md)
 - [ResponsePackHotel](docs/ResponsePackHotel.md)
 - [ResponsePackHotelBooking](docs/ResponsePackHotelBooking.md)
 - [ResponsePackHotelDetails](docs/ResponsePackHotelDetails.md)
 - [ResponsePackHotelPrebook](docs/ResponsePackHotelPrebook.md)
 - [ResponsePackLoginResponse](docs/ResponsePackLoginResponse.md)
 - [ResponsePackPassivePnrBook](docs/ResponsePackPassivePnrBook.md)
 - [ResponsePackString](docs/ResponsePackString.md)
 - [ResponseParameters](docs/ResponseParameters.md)
 - [ReturnTransfer](docs/ReturnTransfer.md)
 - [Room](docs/Room.md)
 - [RoomBookingInfo](docs/RoomBookingInfo.md)
 - [RoomFacility](docs/RoomFacility.md)
 - [RoomImages](docs/RoomImages.md)
 - [RoomRate](docs/RoomRate.md)
 - [RoomRateHotelSearchApi](docs/RoomRateHotelSearchApi.md)
 - [RoomRq](docs/RoomRq.md)
 - [SeatMap](docs/SeatMap.md)
 - [SegmentPassengerMapping](docs/SegmentPassengerMapping.md)
 - [SegmentReference](docs/SegmentReference.md)
 - [SelectedAncillary](docs/SelectedAncillary.md)
 - [SelectedAncillaryData](docs/SelectedAncillaryData.md)
 - [StayDateRange](docs/StayDateRange.md)
 - [SubSection](docs/SubSection.md)
 - [Supplement](docs/Supplement.md)
 - [SupplierAdditionalFareInfo](docs/SupplierAdditionalFareInfo.md)
 - [SupplierClaim](docs/SupplierClaim.md)
 - [Tax](docs/Tax.md)
 - [TaxAirSearchApi](docs/TaxAirSearchApi.md)
 - [TaxDetails](docs/TaxDetails.md)
 - [TicketDocument](docs/TicketDocument.md)
 - [TourCode](docs/TourCode.md)
 - [TransferPassiveSegment](docs/TransferPassiveSegment.md)
 - [TransferPreference](docs/TransferPreference.md)
 - [TransmissionInfo](docs/TransmissionInfo.md)
 - [UserLoginDetails](docs/UserLoginDetails.md)
 - [UserReview](docs/UserReview.md)
 - [VehicleCharge](docs/VehicleCharge.md)
 - [VehicleChargeReservationServiceApi](docs/VehicleChargeReservationServiceApi.md)
 - [VehicleDetails](docs/VehicleDetails.md)
 - [VehicleFinancialInfo](docs/VehicleFinancialInfo.md)
 - [VehicleInfo](docs/VehicleInfo.md)
 - [VehicleInfoReservationServiceApi](docs/VehicleInfoReservationServiceApi.md)
 - [VehicleLocationDetails](docs/VehicleLocationDetails.md)
 - [VehiclePassengerDetails](docs/VehiclePassengerDetails.md)
 - [VehiclePaymentInfo](docs/VehiclePaymentInfo.md)
 - [VehicleRate](docs/VehicleRate.md)
 - [VehicleRateReservationServiceApi](docs/VehicleRateReservationServiceApi.md)
 - [VehicleTypeInfo](docs/VehicleTypeInfo.md)
 - [VoucherDocument](docs/VoucherDocument.md)
 - [Warning](docs/Warning.md)
 - [WorkingHoursDetail](docs/WorkingHoursDetail.md)

## Documentation for Authorization

All endpoints do not require authorization.
Authentication schemes defined for the API:

## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author


