# AirSearchServiceApi

All URIs are relative to *https://api.travlinq.provesio.com/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**performAirSearchRq**](AirSearchServiceApi.md#performAirSearchRq) | **POST** /api/v1/flight/search | Air search
[**performFareRuleSearchRq**](AirSearchServiceApi.md#performFareRuleSearchRq) | **POST** /api/v1/flight/fare-rule-search | Air fare rules
[**performMoreFaresSearchRq**](AirSearchServiceApi.md#performMoreFaresSearchRq) | **POST** /api/v1/flight/more-fares | Air more fare search

<a name="performAirSearchRq"></a>
# **performAirSearchRq**
> ResponsePackAir performAirSearchRq(body, sessionId, conversationId, X_API_KEY)

Air search

Get Air search response

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AirSearchServiceApi;


AirSearchServiceApi apiInstance = new AirSearchServiceApi();
AirCriteria body = new AirCriteria(); // AirCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performAirSearchRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AirSearchServiceApi#performAirSearchRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirCriteria**](AirCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performFareRuleSearchRq"></a>
# **performFareRuleSearchRq**
> ResponsePackAirFareRuleResult performFareRuleSearchRq(body, sessionId, conversationId, X_API_KEY)

Air fare rules

Get Air fare rules

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AirSearchServiceApi;


AirSearchServiceApi apiInstance = new AirSearchServiceApi();
AirFareRuleCriteria body = new AirFareRuleCriteria(); // AirFareRuleCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirFareRuleResult result = apiInstance.performFareRuleSearchRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AirSearchServiceApi#performFareRuleSearchRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirFareRuleCriteria**](AirFareRuleCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirFareRuleResult**](ResponsePackAirFareRuleResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performMoreFaresSearchRq"></a>
# **performMoreFaresSearchRq**
> ResponsePackAir performMoreFaresSearchRq(body, sessionId, conversationId, X_API_KEY)

Air more fare search

Get Air more fares

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AirSearchServiceApi;


AirSearchServiceApi apiInstance = new AirSearchServiceApi();
MoreFaresCriteria body = new MoreFaresCriteria(); // MoreFaresCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performMoreFaresSearchRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AirSearchServiceApi#performMoreFaresSearchRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**MoreFaresCriteria**](MoreFaresCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

