# AuthServiceApi

All URIs are relative to *https://api.travlinq.provesio.com/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**loginUser**](AuthServiceApi.md#loginUser) | **POST** /api/v1/auth/login | Login user
[**logoutUser**](AuthServiceApi.md#logoutUser) | **POST** /api/v1/auth/logout | Logout use

<a name="loginUser"></a>
# **loginUser**
> ResponsePackLoginResponse loginUser(body, conversationId, X_API_KEY)

Login user

Get session id by loggin in

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AuthServiceApi;


AuthServiceApi apiInstance = new AuthServiceApi();
UserLoginDetails body = new UserLoginDetails(); // UserLoginDetails | 
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackLoginResponse result = apiInstance.loginUser(body, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceApi#loginUser");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**UserLoginDetails**](UserLoginDetails.md)|  |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackLoginResponse**](ResponsePackLoginResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="logoutUser"></a>
# **logoutUser**
> ResponsePackString logoutUser(sessionId, conversationId, X_API_KEY)

Logout use

Logout from the session

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.AuthServiceApi;


AuthServiceApi apiInstance = new AuthServiceApi();
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackString result = apiInstance.logoutUser(sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AuthServiceApi#logoutUser");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackString**](ResponsePackString.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, */*

