# HotelSearchServiceApi

All URIs are relative to *https://api.travlinq.provesio.com/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**performCancellationPoliciesRq**](HotelSearchServiceApi.md#performCancellationPoliciesRq) | **POST** /api/v1/hotel/cancellation-policy | Get Hotel Cancellation Policies
[**performHotelDetailSearchRq**](HotelSearchServiceApi.md#performHotelDetailSearchRq) | **POST** /api/v1/hotel/details | Hotel Detail Search
[**performHotelSearchRq**](HotelSearchServiceApi.md#performHotelSearchRq) | **POST** /api/v1/hotel/search | Hotel Search
[**performMoreRoomRq**](HotelSearchServiceApi.md#performMoreRoomRq) | **POST** /api/v1/hotel/more-rooms | Hotel Search Get More Rooms

<a name="performCancellationPoliciesRq"></a>
# **performCancellationPoliciesRq**
> ResponsePackCancellationPolicy performCancellationPoliciesRq(body, sessionId, conversationId, X_API_KEY)

Get Hotel Cancellation Policies

Get Hotel Cancellation Policies

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HotelSearchServiceApi;


HotelSearchServiceApi apiInstance = new HotelSearchServiceApi();
HotelCancellationPolicyCriteria body = new HotelCancellationPolicyCriteria(); // HotelCancellationPolicyCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackCancellationPolicy result = apiInstance.performCancellationPoliciesRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HotelSearchServiceApi#performCancellationPoliciesRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HotelCancellationPolicyCriteria**](HotelCancellationPolicyCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackCancellationPolicy**](ResponsePackCancellationPolicy.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelDetailSearchRq"></a>
# **performHotelDetailSearchRq**
> ResponsePackHotelDetails performHotelDetailSearchRq(body, sessionId, conversationId, X_API_KEY)

Hotel Detail Search

Hotel detail search

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HotelSearchServiceApi;


HotelSearchServiceApi apiInstance = new HotelSearchServiceApi();
BaseHotelCriteria body = new BaseHotelCriteria(); // BaseHotelCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotelDetails result = apiInstance.performHotelDetailSearchRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HotelSearchServiceApi#performHotelDetailSearchRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BaseHotelCriteria**](BaseHotelCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotelDetails**](ResponsePackHotelDetails.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelSearchRq"></a>
# **performHotelSearchRq**
> ResponsePackHotel performHotelSearchRq(body, sessionId, conversationId, X_API_KEY)

Hotel Search

Hotel search

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HotelSearchServiceApi;


HotelSearchServiceApi apiInstance = new HotelSearchServiceApi();
HotelSearchCriteria body = new HotelSearchCriteria(); // HotelSearchCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotel result = apiInstance.performHotelSearchRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HotelSearchServiceApi#performHotelSearchRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HotelSearchCriteria**](HotelSearchCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotel**](ResponsePackHotel.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performMoreRoomRq"></a>
# **performMoreRoomRq**
> ResponsePackHotel performMoreRoomRq(body, sessionId, conversationId, X_API_KEY)

Hotel Search Get More Rooms

Hotel search get more rooms

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.HotelSearchServiceApi;


HotelSearchServiceApi apiInstance = new HotelSearchServiceApi();
BaseHotelCriteria body = new BaseHotelCriteria(); // BaseHotelCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotel result = apiInstance.performMoreRoomRq(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling HotelSearchServiceApi#performMoreRoomRq");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BaseHotelCriteria**](BaseHotelCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotel**](ResponsePackHotel.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

