# ReservationServiceApi

All URIs are relative to *https://api.travlinq.provesio.com/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAirCancellationCharges**](ReservationServiceApi.md#getAirCancellationCharges) | **POST** /api/v1/reservation/flight-cancellation-charge | Flight cancellation charges
[**performAirBooking**](ReservationServiceApi.md#performAirBooking) | **POST** /api/v1/reservation/flight-book | Flight book
[**performAirBookingRetrieve**](ReservationServiceApi.md#performAirBookingRetrieve) | **POST** /api/v1/reservation/flight-book-retrieve | Flight Booking Retrieve
[**performAirCancel**](ReservationServiceApi.md#performAirCancel) | **POST** /api/v1/reservation/flight-cancel | Flight cancel
[**performAirPassivePnrBooking**](ReservationServiceApi.md#performAirPassivePnrBooking) | **POST** /api/v1/reservation/flight-passive-pnr | Flight Passive PNR Book
[**performAirProvisionalBooking**](ReservationServiceApi.md#performAirProvisionalBooking) | **POST** /api/v1/reservation/flight-prov-book | Flight provisional book
[**performAirReInitiateBooking**](ReservationServiceApi.md#performAirReInitiateBooking) | **POST** /api/v1/reservation/flight-re-initiate-booking | Flight Re-Initiate Booking
[**performAncillaryBookRequest**](ReservationServiceApi.md#performAncillaryBookRequest) | **POST** /api/v1/reservation/ancillary-book | Ancillary Book
[**performAncillaryDirectBookRequest**](ReservationServiceApi.md#performAncillaryDirectBookRequest) | **POST** /api/v1/reservation/ancillary-direct-book | Ancillary Direct Book
[**performAncillaryProBookRequest**](ReservationServiceApi.md#performAncillaryProBookRequest) | **POST** /api/v1/reservation/ancillary-prov-book | Ancillary Prov Book
[**performAncillarySearchRequest**](ReservationServiceApi.md#performAncillarySearchRequest) | **POST** /api/v1/reservation/ancillary-search | Ancillary search
[**performCarAddExtras**](ReservationServiceApi.md#performCarAddExtras) | **POST** /api/v1/reservation/car-add-extra | Car Add Extras
[**performCarBook**](ReservationServiceApi.md#performCarBook) | **POST** /api/v1/reservation/car-book | Car Book
[**performCarBookingCancellation**](ReservationServiceApi.md#performCarBookingCancellation) | **POST** /api/v1/reservation/car-cancel | Car Booking Cancellation
[**performCarBookingRetrieve**](ReservationServiceApi.md#performCarBookingRetrieve) | **POST** /api/v1/reservation/car-book-retrieve | Car Booking Retrieve
[**performCarPrebook**](ReservationServiceApi.md#performCarPrebook) | **POST** /api/v1/reservation/car-pre-book | Car Pre Book
[**performHotelBooking**](ReservationServiceApi.md#performHotelBooking) | **POST** /api/v1/reservation/hotel-book | Hotel Book
[**performHotelBookingRetrieve**](ReservationServiceApi.md#performHotelBookingRetrieve) | **POST** /api/v1/reservation/hotel-book-retrieve | Hotel Booking Retrieve
[**performHotelCancel**](ReservationServiceApi.md#performHotelCancel) | **POST** /api/v1/reservation/hotel-cancel | Hotel Book Cancel
[**performHotelPrebook**](ReservationServiceApi.md#performHotelPrebook) | **POST** /api/v1/reservation/hotel-pre-book | Hotel Pre Book
[**performReissueBook**](ReservationServiceApi.md#performReissueBook) | **POST** /api/v1/reservation/flight-reissue-book | Flight Reissue Book
[**performReissueDifferentialFareSearch**](ReservationServiceApi.md#performReissueDifferentialFareSearch) | **POST** /api/v1/reservation/flight-reissue-differential-fare-search | Flight Reissue Differential Fare Search
[**performReissueProvBook**](ReservationServiceApi.md#performReissueProvBook) | **POST** /api/v1/reservation/flight-reissue-prov-book | Flight Reissue Prov Book
[**performReissueSearch**](ReservationServiceApi.md#performReissueSearch) | **POST** /api/v1/reservation/flight-reissue-search | Flight Reissue Search

<a name="getAirCancellationCharges"></a>
# **getAirCancellationCharges**
> ResponsePackAirCancellationCharges getAirCancellationCharges(body, sessionId, conversationId, X_API_KEY)

Flight cancellation charges

Flight cancellation charges

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirCancellationCriteria body = new AirCancellationCriteria(); // AirCancellationCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirCancellationCharges result = apiInstance.getAirCancellationCharges(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#getAirCancellationCharges");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirCancellationCriteria**](AirCancellationCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirCancellationCharges**](ResponsePackAirCancellationCharges.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirBooking"></a>
# **performAirBooking**
> ResponsePackAirBooking performAirBooking(body, sessionId, conversationId, X_API_KEY)

Flight book

Flight book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirBookCriteria body = new AirBookCriteria(); // AirBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirBooking result = apiInstance.performAirBooking(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirBooking");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirBookCriteria**](AirBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirBooking**](ResponsePackAirBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirBookingRetrieve"></a>
# **performAirBookingRetrieve**
> ResponsePackAirBooking performAirBookingRetrieve(body, sessionId, conversationId, X_API_KEY)

Flight Booking Retrieve

Flight Booking Retrieve

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirBookingRetrievalCriteria body = new AirBookingRetrievalCriteria(); // AirBookingRetrievalCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirBooking result = apiInstance.performAirBookingRetrieve(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirBookingRetrieve");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirBookingRetrievalCriteria**](AirBookingRetrievalCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirBooking**](ResponsePackAirBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirCancel"></a>
# **performAirCancel**
> ResponsePackAirCancel performAirCancel(body, sessionId, conversationId, X_API_KEY)

Flight cancel

Flight cancel

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirCancellationCriteria body = new AirCancellationCriteria(); // AirCancellationCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirCancel result = apiInstance.performAirCancel(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirCancel");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirCancellationCriteria**](AirCancellationCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirCancel**](ResponsePackAirCancel.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirPassivePnrBooking"></a>
# **performAirPassivePnrBooking**
> ResponsePackPassivePnrBook performAirPassivePnrBooking(body, sessionId, conversationId, X_API_KEY)

Flight Passive PNR Book

Flight Passive PNR Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirPassivePnrBookCriteria body = new AirPassivePnrBookCriteria(); // AirPassivePnrBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackPassivePnrBook result = apiInstance.performAirPassivePnrBooking(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirPassivePnrBooking");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirPassivePnrBookCriteria**](AirPassivePnrBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackPassivePnrBook**](ResponsePackPassivePnrBook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirProvisionalBooking"></a>
# **performAirProvisionalBooking**
> ResponsePackAir performAirProvisionalBooking(body, sessionId, conversationId, X_API_KEY)

Flight provisional book

Flight provisional book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirProvBookCriteria body = new AirProvBookCriteria(); // AirProvBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performAirProvisionalBooking(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirProvisionalBooking");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirProvBookCriteria**](AirProvBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAirReInitiateBooking"></a>
# **performAirReInitiateBooking**
> ResponsePackAirBooking performAirReInitiateBooking(body, sessionId, conversationId, X_API_KEY)

Flight Re-Initiate Booking

Flight Re-Initiate Booking

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirBookCriteria body = new AirBookCriteria(); // AirBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirBooking result = apiInstance.performAirReInitiateBooking(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAirReInitiateBooking");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirBookCriteria**](AirBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirBooking**](ResponsePackAirBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAncillaryBookRequest"></a>
# **performAncillaryBookRequest**
> ResponsePackAncillaryBooking performAncillaryBookRequest(body, sessionId, conversationId, X_API_KEY)

Ancillary Book

Ancillary Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AncillaryBookCriteria body = new AncillaryBookCriteria(); // AncillaryBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAncillaryBooking result = apiInstance.performAncillaryBookRequest(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAncillaryBookRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AncillaryBookCriteria**](AncillaryBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAncillaryBooking**](ResponsePackAncillaryBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAncillaryDirectBookRequest"></a>
# **performAncillaryDirectBookRequest**
> ResponsePackAncillaryBooking performAncillaryDirectBookRequest(body, sessionId, conversationId, X_API_KEY)

Ancillary Direct Book

Ancillary Direct Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AncillaryBookCriteria body = new AncillaryBookCriteria(); // AncillaryBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAncillaryBooking result = apiInstance.performAncillaryDirectBookRequest(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAncillaryDirectBookRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AncillaryBookCriteria**](AncillaryBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAncillaryBooking**](ResponsePackAncillaryBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAncillaryProBookRequest"></a>
# **performAncillaryProBookRequest**
> ResponsePackAncillaryResult performAncillaryProBookRequest(body, sessionId, conversationId, X_API_KEY)

Ancillary Prov Book

Ancillary Prov Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AncillaryProvBookCriteria body = new AncillaryProvBookCriteria(); // AncillaryProvBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAncillaryResult result = apiInstance.performAncillaryProBookRequest(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAncillaryProBookRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AncillaryProvBookCriteria**](AncillaryProvBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAncillaryResult**](ResponsePackAncillaryResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performAncillarySearchRequest"></a>
# **performAncillarySearchRequest**
> ResponsePackAirAncillarySearchResponse performAncillarySearchRequest(body, sessionId, conversationId, X_API_KEY)

Ancillary search

Flight ancillary search request

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AncillarySearchCriteria body = new AncillarySearchCriteria(); // AncillarySearchCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirAncillarySearchResponse result = apiInstance.performAncillarySearchRequest(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performAncillarySearchRequest");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AncillarySearchCriteria**](AncillarySearchCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirAncillarySearchResponse**](ResponsePackAirAncillarySearchResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performCarAddExtras"></a>
# **performCarAddExtras**
> ResponsePackCar performCarAddExtras(body, sessionId, conversationId, X_API_KEY)

Car Add Extras

Car Add Extras

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
CarPreBookCriteria body = new CarPreBookCriteria(); // CarPreBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackCar result = apiInstance.performCarAddExtras(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performCarAddExtras");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CarPreBookCriteria**](CarPreBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackCar**](ResponsePackCar.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performCarBook"></a>
# **performCarBook**
> ResponsePackCarBooking performCarBook(body, sessionId, conversationId, X_API_KEY)

Car Book

Car Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
CarBookingCriteria body = new CarBookingCriteria(); // CarBookingCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackCarBooking result = apiInstance.performCarBook(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performCarBook");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CarBookingCriteria**](CarBookingCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackCarBooking**](ResponsePackCarBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performCarBookingCancellation"></a>
# **performCarBookingCancellation**
> ResponsePackBookingCancellationResponse performCarBookingCancellation(body, sessionId, conversationId, X_API_KEY)

Car Booking Cancellation

Car Booking Cancellation

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
BookingCancellationCriteria body = new BookingCancellationCriteria(); // BookingCancellationCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackBookingCancellationResponse result = apiInstance.performCarBookingCancellation(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performCarBookingCancellation");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BookingCancellationCriteria**](BookingCancellationCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackBookingCancellationResponse**](ResponsePackBookingCancellationResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performCarBookingRetrieve"></a>
# **performCarBookingRetrieve**
> ResponsePackCarBooking performCarBookingRetrieve(body, sessionId, conversationId, X_API_KEY)

Car Booking Retrieve

Car Booking Retrieve

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
CarBookingRetrieveCriteria body = new CarBookingRetrieveCriteria(); // CarBookingRetrieveCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackCarBooking result = apiInstance.performCarBookingRetrieve(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performCarBookingRetrieve");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CarBookingRetrieveCriteria**](CarBookingRetrieveCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackCarBooking**](ResponsePackCarBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performCarPrebook"></a>
# **performCarPrebook**
> ResponsePackCar performCarPrebook(body, sessionId, conversationId, X_API_KEY)

Car Pre Book

Car Pre Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
CarPreBookCriteria body = new CarPreBookCriteria(); // CarPreBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackCar result = apiInstance.performCarPrebook(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performCarPrebook");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CarPreBookCriteria**](CarPreBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackCar**](ResponsePackCar.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelBooking"></a>
# **performHotelBooking**
> ResponsePackHotelBooking performHotelBooking(body, sessionId, conversationId, X_API_KEY)

Hotel Book

Hotel Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
HotelBookingCriteria body = new HotelBookingCriteria(); // HotelBookingCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotelBooking result = apiInstance.performHotelBooking(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performHotelBooking");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HotelBookingCriteria**](HotelBookingCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotelBooking**](ResponsePackHotelBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelBookingRetrieve"></a>
# **performHotelBookingRetrieve**
> ResponsePackHotelBooking performHotelBookingRetrieve(body, sessionId, conversationId, X_API_KEY)

Hotel Booking Retrieve

Hotel Booking Retrieve

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
HotelBookingRetrieveCriteria body = new HotelBookingRetrieveCriteria(); // HotelBookingRetrieveCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotelBooking result = apiInstance.performHotelBookingRetrieve(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performHotelBookingRetrieve");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HotelBookingRetrieveCriteria**](HotelBookingRetrieveCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotelBooking**](ResponsePackHotelBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelCancel"></a>
# **performHotelCancel**
> ResponsePackBookingCancel performHotelCancel(body, sessionId, conversationId, X_API_KEY)

Hotel Book Cancel

Hotel Booking Cancellation

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
BookingCancelCriteria body = new BookingCancelCriteria(); // BookingCancelCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackBookingCancel result = apiInstance.performHotelCancel(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performHotelCancel");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BookingCancelCriteria**](BookingCancelCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackBookingCancel**](ResponsePackBookingCancel.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performHotelPrebook"></a>
# **performHotelPrebook**
> ResponsePackHotelPrebook performHotelPrebook(body, sessionId, conversationId, X_API_KEY)

Hotel Pre Book

Hotel Pre Book

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
HotelPreBookCriteria body = new HotelPreBookCriteria(); // HotelPreBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackHotelPrebook result = apiInstance.performHotelPrebook(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performHotelPrebook");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HotelPreBookCriteria**](HotelPreBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackHotelPrebook**](ResponsePackHotelPrebook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performReissueBook"></a>
# **performReissueBook**
> ResponsePackAirBooking performReissueBook(body, sessionId, conversationId, X_API_KEY)

Flight Reissue Book

Get flight reissue booking

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirBookCriteria body = new AirBookCriteria(); // AirBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAirBooking result = apiInstance.performReissueBook(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performReissueBook");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirBookCriteria**](AirBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAirBooking**](ResponsePackAirBooking.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performReissueDifferentialFareSearch"></a>
# **performReissueDifferentialFareSearch**
> ResponsePackAir performReissueDifferentialFareSearch(body, sessionId, conversationId, X_API_KEY)

Flight Reissue Differential Fare Search

Get flight reissue differential fare search

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
MoreFaresCriteria body = new MoreFaresCriteria(); // MoreFaresCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performReissueDifferentialFareSearch(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performReissueDifferentialFareSearch");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**MoreFaresCriteria**](MoreFaresCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performReissueProvBook"></a>
# **performReissueProvBook**
> ResponsePackAir performReissueProvBook(body, sessionId, conversationId, X_API_KEY)

Flight Reissue Prov Book

Get flight reissue prov booking

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirProvBookCriteria body = new AirProvBookCriteria(); // AirProvBookCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performReissueProvBook(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performReissueProvBook");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirProvBookCriteria**](AirProvBookCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

<a name="performReissueSearch"></a>
# **performReissueSearch**
> ResponsePackAir performReissueSearch(body, sessionId, conversationId, X_API_KEY)

Flight Reissue Search

Get flight reissue search

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ReservationServiceApi;


ReservationServiceApi apiInstance = new ReservationServiceApi();
AirCriteria body = new AirCriteria(); // AirCriteria | 
String sessionId = "sessionId_example"; // String | Session ID
String conversationId = "conversationId_example"; // String | Conversation ID
String X_API_KEY = "X_API_KEY_example"; // String | API access key
try {
    ResponsePackAir result = apiInstance.performReissueSearch(body, sessionId, conversationId, X_API_KEY);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReservationServiceApi#performReissueSearch");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AirCriteria**](AirCriteria.md)|  |
 **sessionId** | **String**| Session ID |
 **conversationId** | **String**| Conversation ID |
 **X_API_KEY** | **String**| API access key |

### Return type

[**ResponsePackAir**](ResponsePackAir.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json, */*

