/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.CarCancellationPolicyCriteria;
import io.swagger.client.model.CarSearchCriteria;
import io.swagger.client.model.ResponsePackCar;
import io.swagger.client.model.ResponsePackCarCancellationPolicyResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CarSearchServiceApi {
    private ApiClient apiClient;

    public CarSearchServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CarSearchServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getCancellationPolicy
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCancellationPolicyCall(CarCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/car/cancellation-policy";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCancellationPolicyValidateBeforeCall(CarCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getCancellationPolicy(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling getCancellationPolicy(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling getCancellationPolicy(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling getCancellationPolicy(Async)");
        }
        
        com.squareup.okhttp.Call call = getCancellationPolicyCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Book
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCarCancellationPolicyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCarCancellationPolicyResponse getCancellationPolicy(CarCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCarCancellationPolicyResponse> resp = getCancellationPolicyWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Book
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCarCancellationPolicyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCarCancellationPolicyResponse> getCancellationPolicyWithHttpInfo(CarCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = getCancellationPolicyValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCarCancellationPolicyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Book (asynchronously)
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCancellationPolicyAsync(CarCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCarCancellationPolicyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCancellationPolicyValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCarCancellationPolicyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarSearch
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarSearchCall(CarSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/car/search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarSearchValidateBeforeCall(CarSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarSearch(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarSearch(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarSearch(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarSearch(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarSearchCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car search
     * Car Search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCar
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCar performCarSearch(CarSearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCar> resp = performCarSearchWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car search
     * Car Search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCar&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCar> performCarSearchWithHttpInfo(CarSearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car search (asynchronously)
     * Car Search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarSearchAsync(CarSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCar> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
