/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.AirBookCriteria;
import io.swagger.client.model.AirBookingRetrievalCriteria;
import io.swagger.client.model.AirCancellationCriteria;
import io.swagger.client.model.AirCriteria;
import io.swagger.client.model.AirPassivePnrBookCriteria;
import io.swagger.client.model.AirProvBookCriteria;
import io.swagger.client.model.AncillaryBookCriteria;
import io.swagger.client.model.AncillaryProvBookCriteria;
import io.swagger.client.model.AncillarySearchCriteria;
import io.swagger.client.model.BookingCancelCriteria;
import io.swagger.client.model.BookingCancellationCriteria;
import io.swagger.client.model.CarBookingCriteria;
import io.swagger.client.model.CarBookingRetrieveCriteria;
import io.swagger.client.model.CarPreBookCriteria;
import io.swagger.client.model.HotelBookingCriteria;
import io.swagger.client.model.HotelBookingRetrieveCriteria;
import io.swagger.client.model.HotelPreBookCriteria;
import io.swagger.client.model.MoreFaresCriteria;
import io.swagger.client.model.ResponsePackAir;
import io.swagger.client.model.ResponsePackAirAncillarySearchResponse;
import io.swagger.client.model.ResponsePackAirBooking;
import io.swagger.client.model.ResponsePackAirCancel;
import io.swagger.client.model.ResponsePackAirCancellationCharges;
import io.swagger.client.model.ResponsePackAncillaryBooking;
import io.swagger.client.model.ResponsePackAncillaryResult;
import io.swagger.client.model.ResponsePackBookingCancel;
import io.swagger.client.model.ResponsePackBookingCancellationResponse;
import io.swagger.client.model.ResponsePackCar;
import io.swagger.client.model.ResponsePackCarBooking;
import io.swagger.client.model.ResponsePackHotelBooking;
import io.swagger.client.model.ResponsePackHotelPrebook;
import io.swagger.client.model.ResponsePackPassivePnrBook;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ReservationServiceApi {
    private ApiClient apiClient;

    public ReservationServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ReservationServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getAirCancellationCharges
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getAirCancellationChargesCall(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-cancellation-charge";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getAirCancellationChargesValidateBeforeCall(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getAirCancellationCharges(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling getAirCancellationCharges(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling getAirCancellationCharges(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling getAirCancellationCharges(Async)");
        }
        
        com.squareup.okhttp.Call call = getAirCancellationChargesCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight cancellation charges
     * Flight cancellation charges
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirCancellationCharges
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirCancellationCharges getAirCancellationCharges(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirCancellationCharges> resp = getAirCancellationChargesWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight cancellation charges
     * Flight cancellation charges
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirCancellationCharges&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirCancellationCharges> getAirCancellationChargesWithHttpInfo(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = getAirCancellationChargesValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirCancellationCharges>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight cancellation charges (asynchronously)
     * Flight cancellation charges
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getAirCancellationChargesAsync(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirCancellationCharges> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getAirCancellationChargesValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirCancellationCharges>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirBooking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirBookingCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirBookingValidateBeforeCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirBooking(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirBooking(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirBooking(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirBooking(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirBookingCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight book
     * Flight book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirBooking performAirBooking(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirBooking> resp = performAirBookingWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight book
     * Flight book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirBooking> performAirBookingWithHttpInfo(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight book (asynchronously)
     * Flight book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirBookingAsync(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirBookingRetrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirBookingRetrieveCall(AirBookingRetrievalCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-book-retrieve";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirBookingRetrieveValidateBeforeCall(AirBookingRetrievalCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirBookingRetrieve(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirBookingRetrieve(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirBookingRetrieve(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirBookingRetrieve(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirBookingRetrieveCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Booking Retrieve
     * Flight Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirBooking performAirBookingRetrieve(AirBookingRetrievalCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirBooking> resp = performAirBookingRetrieveWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Booking Retrieve
     * Flight Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirBooking> performAirBookingRetrieveWithHttpInfo(AirBookingRetrievalCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Booking Retrieve (asynchronously)
     * Flight Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirBookingRetrieveAsync(AirBookingRetrievalCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirCancel
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirCancelCall(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-cancel";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirCancelValidateBeforeCall(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirCancel(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirCancel(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirCancel(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirCancel(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirCancelCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight cancel
     * Flight cancel
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirCancel
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirCancel performAirCancel(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirCancel> resp = performAirCancelWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight cancel
     * Flight cancel
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirCancel&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirCancel> performAirCancelWithHttpInfo(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirCancelValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirCancel>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight cancel (asynchronously)
     * Flight cancel
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirCancelAsync(AirCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirCancel> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirCancelValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirCancel>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirPassivePnrBooking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirPassivePnrBookingCall(AirPassivePnrBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-passive-pnr";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirPassivePnrBookingValidateBeforeCall(AirPassivePnrBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirPassivePnrBooking(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirPassivePnrBooking(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirPassivePnrBooking(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirPassivePnrBooking(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirPassivePnrBookingCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Passive PNR Book
     * Flight Passive PNR Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackPassivePnrBook
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackPassivePnrBook performAirPassivePnrBooking(AirPassivePnrBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackPassivePnrBook> resp = performAirPassivePnrBookingWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Passive PNR Book
     * Flight Passive PNR Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackPassivePnrBook&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackPassivePnrBook> performAirPassivePnrBookingWithHttpInfo(AirPassivePnrBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirPassivePnrBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackPassivePnrBook>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Passive PNR Book (asynchronously)
     * Flight Passive PNR Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirPassivePnrBookingAsync(AirPassivePnrBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackPassivePnrBook> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirPassivePnrBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackPassivePnrBook>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirProvisionalBooking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirProvisionalBookingCall(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-prov-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirProvisionalBookingValidateBeforeCall(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirProvisionalBooking(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirProvisionalBooking(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirProvisionalBooking(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirProvisionalBooking(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirProvisionalBookingCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight provisional book
     * Flight provisional book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performAirProvisionalBooking(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performAirProvisionalBookingWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight provisional book
     * Flight provisional book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performAirProvisionalBookingWithHttpInfo(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirProvisionalBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight provisional book (asynchronously)
     * Flight provisional book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirProvisionalBookingAsync(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirProvisionalBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAirReInitiateBooking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirReInitiateBookingCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-re-initiate-booking";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirReInitiateBookingValidateBeforeCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirReInitiateBooking(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirReInitiateBooking(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirReInitiateBooking(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirReInitiateBooking(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirReInitiateBookingCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Re-Initiate Booking
     * Flight Re-Initiate Booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirBooking performAirReInitiateBooking(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirBooking> resp = performAirReInitiateBookingWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Re-Initiate Booking
     * Flight Re-Initiate Booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirBooking> performAirReInitiateBookingWithHttpInfo(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirReInitiateBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Re-Initiate Booking (asynchronously)
     * Flight Re-Initiate Booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirReInitiateBookingAsync(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirReInitiateBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAncillaryBookRequest
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAncillaryBookRequestCall(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/ancillary-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAncillaryBookRequestValidateBeforeCall(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAncillaryBookRequest(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAncillaryBookRequest(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAncillaryBookRequest(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAncillaryBookRequest(Async)");
        }
        
        com.squareup.okhttp.Call call = performAncillaryBookRequestCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Ancillary Book
     * Ancillary Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAncillaryBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAncillaryBooking performAncillaryBookRequest(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAncillaryBooking> resp = performAncillaryBookRequestWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Ancillary Book
     * Ancillary Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAncillaryBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAncillaryBooking> performAncillaryBookRequestWithHttpInfo(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAncillaryBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Ancillary Book (asynchronously)
     * Ancillary Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAncillaryBookRequestAsync(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAncillaryBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAncillaryBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAncillaryDirectBookRequest
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAncillaryDirectBookRequestCall(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/ancillary-direct-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAncillaryDirectBookRequestValidateBeforeCall(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAncillaryDirectBookRequest(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAncillaryDirectBookRequest(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAncillaryDirectBookRequest(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAncillaryDirectBookRequest(Async)");
        }
        
        com.squareup.okhttp.Call call = performAncillaryDirectBookRequestCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Ancillary Direct Book
     * Ancillary Direct Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAncillaryBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAncillaryBooking performAncillaryDirectBookRequest(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAncillaryBooking> resp = performAncillaryDirectBookRequestWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Ancillary Direct Book
     * Ancillary Direct Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAncillaryBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAncillaryBooking> performAncillaryDirectBookRequestWithHttpInfo(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAncillaryDirectBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Ancillary Direct Book (asynchronously)
     * Ancillary Direct Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAncillaryDirectBookRequestAsync(AncillaryBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAncillaryBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAncillaryDirectBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAncillaryProBookRequest
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAncillaryProBookRequestCall(AncillaryProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/ancillary-prov-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAncillaryProBookRequestValidateBeforeCall(AncillaryProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAncillaryProBookRequest(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAncillaryProBookRequest(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAncillaryProBookRequest(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAncillaryProBookRequest(Async)");
        }
        
        com.squareup.okhttp.Call call = performAncillaryProBookRequestCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Ancillary Prov Book
     * Ancillary Prov Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAncillaryResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAncillaryResult performAncillaryProBookRequest(AncillaryProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAncillaryResult> resp = performAncillaryProBookRequestWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Ancillary Prov Book
     * Ancillary Prov Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAncillaryResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAncillaryResult> performAncillaryProBookRequestWithHttpInfo(AncillaryProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAncillaryProBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Ancillary Prov Book (asynchronously)
     * Ancillary Prov Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAncillaryProBookRequestAsync(AncillaryProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAncillaryResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAncillaryProBookRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAncillaryResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performAncillarySearchRequest
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAncillarySearchRequestCall(AncillarySearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/ancillary-search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAncillarySearchRequestValidateBeforeCall(AncillarySearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAncillarySearchRequest(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAncillarySearchRequest(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAncillarySearchRequest(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAncillarySearchRequest(Async)");
        }
        
        com.squareup.okhttp.Call call = performAncillarySearchRequestCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Ancillary search
     * Flight ancillary search request
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirAncillarySearchResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirAncillarySearchResponse performAncillarySearchRequest(AncillarySearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirAncillarySearchResponse> resp = performAncillarySearchRequestWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Ancillary search
     * Flight ancillary search request
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirAncillarySearchResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirAncillarySearchResponse> performAncillarySearchRequestWithHttpInfo(AncillarySearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAncillarySearchRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirAncillarySearchResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Ancillary search (asynchronously)
     * Flight ancillary search request
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAncillarySearchRequestAsync(AncillarySearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirAncillarySearchResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAncillarySearchRequestValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirAncillarySearchResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarAddExtras
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarAddExtrasCall(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/car-add-extra";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarAddExtrasValidateBeforeCall(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarAddExtras(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarAddExtras(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarAddExtras(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarAddExtras(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarAddExtrasCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Add Extras
     * Car Add Extras
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCar
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCar performCarAddExtras(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCar> resp = performCarAddExtrasWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Add Extras
     * Car Add Extras
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCar&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCar> performCarAddExtrasWithHttpInfo(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarAddExtrasValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Add Extras (asynchronously)
     * Car Add Extras
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarAddExtrasAsync(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCar> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarAddExtrasValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarBook
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarBookCall(CarBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/car-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarBookValidateBeforeCall(CarBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarBook(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarBook(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarBook(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarBook(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarBookCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Book
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCarBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCarBooking performCarBook(CarBookingCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCarBooking> resp = performCarBookWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Book
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCarBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCarBooking> performCarBookWithHttpInfo(CarBookingCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCarBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Book (asynchronously)
     * Car Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarBookAsync(CarBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCarBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCarBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarBookingCancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarBookingCancellationCall(BookingCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/car-cancel";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarBookingCancellationValidateBeforeCall(BookingCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarBookingCancellation(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarBookingCancellation(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarBookingCancellation(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarBookingCancellation(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarBookingCancellationCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Booking Cancellation
     * Car Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackBookingCancellationResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackBookingCancellationResponse performCarBookingCancellation(BookingCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackBookingCancellationResponse> resp = performCarBookingCancellationWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Booking Cancellation
     * Car Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackBookingCancellationResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackBookingCancellationResponse> performCarBookingCancellationWithHttpInfo(BookingCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarBookingCancellationValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackBookingCancellationResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Booking Cancellation (asynchronously)
     * Car Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarBookingCancellationAsync(BookingCancellationCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackBookingCancellationResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarBookingCancellationValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackBookingCancellationResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarBookingRetrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarBookingRetrieveCall(CarBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/car-book-retrieve";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarBookingRetrieveValidateBeforeCall(CarBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarBookingRetrieve(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarBookingRetrieve(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarBookingRetrieve(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarBookingRetrieve(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarBookingRetrieveCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Booking Retrieve
     * Car Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCarBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCarBooking performCarBookingRetrieve(CarBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCarBooking> resp = performCarBookingRetrieveWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Booking Retrieve
     * Car Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCarBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCarBooking> performCarBookingRetrieveWithHttpInfo(CarBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCarBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Booking Retrieve (asynchronously)
     * Car Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarBookingRetrieveAsync(CarBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCarBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCarBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performCarPrebook
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCarPrebookCall(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/car-pre-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCarPrebookValidateBeforeCall(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCarPrebook(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCarPrebook(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCarPrebook(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCarPrebook(Async)");
        }
        
        com.squareup.okhttp.Call call = performCarPrebookCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Car Pre Book
     * Car Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCar
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCar performCarPrebook(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCar> resp = performCarPrebookWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Car Pre Book
     * Car Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCar&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCar> performCarPrebookWithHttpInfo(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCarPrebookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Car Pre Book (asynchronously)
     * Car Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCarPrebookAsync(CarPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCar> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCarPrebookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCar>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelBooking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelBookingCall(HotelBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/hotel-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelBookingValidateBeforeCall(HotelBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelBooking(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelBooking(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelBooking(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelBooking(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelBookingCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Book
     * Hotel Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotelBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotelBooking performHotelBooking(HotelBookingCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotelBooking> resp = performHotelBookingWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Book
     * Hotel Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotelBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotelBooking> performHotelBookingWithHttpInfo(HotelBookingCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotelBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Book (asynchronously)
     * Hotel Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelBookingAsync(HotelBookingCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotelBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelBookingValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotelBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelBookingRetrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelBookingRetrieveCall(HotelBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/hotel-book-retrieve";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelBookingRetrieveValidateBeforeCall(HotelBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelBookingRetrieve(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelBookingRetrieve(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelBookingRetrieve(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelBookingRetrieve(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelBookingRetrieveCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Booking Retrieve
     * Hotel Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotelBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotelBooking performHotelBookingRetrieve(HotelBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotelBooking> resp = performHotelBookingRetrieveWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Booking Retrieve
     * Hotel Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotelBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotelBooking> performHotelBookingRetrieveWithHttpInfo(HotelBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotelBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Booking Retrieve (asynchronously)
     * Hotel Booking Retrieve
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelBookingRetrieveAsync(HotelBookingRetrieveCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotelBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelBookingRetrieveValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotelBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelCancel
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelCancelCall(BookingCancelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/hotel-cancel";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelCancelValidateBeforeCall(BookingCancelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelCancel(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelCancel(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelCancel(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelCancel(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelCancelCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Book Cancel
     * Hotel Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackBookingCancel
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackBookingCancel performHotelCancel(BookingCancelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackBookingCancel> resp = performHotelCancelWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Book Cancel
     * Hotel Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackBookingCancel&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackBookingCancel> performHotelCancelWithHttpInfo(BookingCancelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelCancelValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackBookingCancel>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Book Cancel (asynchronously)
     * Hotel Booking Cancellation
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelCancelAsync(BookingCancelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackBookingCancel> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelCancelValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackBookingCancel>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelPrebook
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelPrebookCall(HotelPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/hotel-pre-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelPrebookValidateBeforeCall(HotelPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelPrebook(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelPrebook(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelPrebook(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelPrebook(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelPrebookCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Pre Book
     * Hotel Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotelPrebook
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotelPrebook performHotelPrebook(HotelPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotelPrebook> resp = performHotelPrebookWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Pre Book
     * Hotel Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotelPrebook&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotelPrebook> performHotelPrebookWithHttpInfo(HotelPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelPrebookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotelPrebook>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Pre Book (asynchronously)
     * Hotel Pre Book
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelPrebookAsync(HotelPreBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotelPrebook> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelPrebookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotelPrebook>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performReissueBook
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performReissueBookCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-reissue-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performReissueBookValidateBeforeCall(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performReissueBook(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performReissueBook(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performReissueBook(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performReissueBook(Async)");
        }
        
        com.squareup.okhttp.Call call = performReissueBookCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Reissue Book
     * Get flight reissue booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirBooking
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirBooking performReissueBook(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirBooking> resp = performReissueBookWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Reissue Book
     * Get flight reissue booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirBooking&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirBooking> performReissueBookWithHttpInfo(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performReissueBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Reissue Book (asynchronously)
     * Get flight reissue booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performReissueBookAsync(AirBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirBooking> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performReissueBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirBooking>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performReissueDifferentialFareSearch
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performReissueDifferentialFareSearchCall(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-reissue-differential-fare-search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performReissueDifferentialFareSearchValidateBeforeCall(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performReissueDifferentialFareSearch(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performReissueDifferentialFareSearch(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performReissueDifferentialFareSearch(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performReissueDifferentialFareSearch(Async)");
        }
        
        com.squareup.okhttp.Call call = performReissueDifferentialFareSearchCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Reissue Differential Fare Search
     * Get flight reissue differential fare search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performReissueDifferentialFareSearch(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performReissueDifferentialFareSearchWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Reissue Differential Fare Search
     * Get flight reissue differential fare search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performReissueDifferentialFareSearchWithHttpInfo(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performReissueDifferentialFareSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Reissue Differential Fare Search (asynchronously)
     * Get flight reissue differential fare search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performReissueDifferentialFareSearchAsync(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performReissueDifferentialFareSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performReissueProvBook
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performReissueProvBookCall(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-reissue-prov-book";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performReissueProvBookValidateBeforeCall(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performReissueProvBook(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performReissueProvBook(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performReissueProvBook(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performReissueProvBook(Async)");
        }
        
        com.squareup.okhttp.Call call = performReissueProvBookCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Reissue Prov Book
     * Get flight reissue prov booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performReissueProvBook(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performReissueProvBookWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Reissue Prov Book
     * Get flight reissue prov booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performReissueProvBookWithHttpInfo(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performReissueProvBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Reissue Prov Book (asynchronously)
     * Get flight reissue prov booking
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performReissueProvBookAsync(AirProvBookCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performReissueProvBookValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performReissueSearch
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performReissueSearchCall(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/reservation/flight-reissue-search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performReissueSearchValidateBeforeCall(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performReissueSearch(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performReissueSearch(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performReissueSearch(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performReissueSearch(Async)");
        }
        
        com.squareup.okhttp.Call call = performReissueSearchCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Flight Reissue Search
     * Get flight reissue search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performReissueSearch(AirCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performReissueSearchWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Flight Reissue Search
     * Get flight reissue search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performReissueSearchWithHttpInfo(AirCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performReissueSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Flight Reissue Search (asynchronously)
     * Get flight reissue search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performReissueSearchAsync(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performReissueSearchValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
