/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.BookingRoom;
import io.swagger.client.model.HotelPaymentDetails;
import io.swagger.client.model.StayDateRange;
import io.swagger.client.model.TaxDetails;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * HotelBookingCriteria
 */


public class HotelBookingCriteria {
  @SerializedName("searchKey")
  private String searchKey = null;

  @SerializedName("clientReference")
  private String clientReference = null;

  @SerializedName("bookingKey")
  private String bookingKey = null;

  @SerializedName("hotelKey")
  private String hotelKey = null;

  @SerializedName("totalNet")
  private Double totalNet = null;

  @SerializedName("currency")
  private String currency = null;

  @SerializedName("culture")
  private String culture = null;

  @SerializedName("stayDateRange")
  private StayDateRange stayDateRange = null;

  @SerializedName("rooms")
  private List<BookingRoom> rooms = null;

  @SerializedName("taxDetails")
  private TaxDetails taxDetails = null;

  @SerializedName("paymentDetails")
  private HotelPaymentDetails paymentDetails = null;

  public HotelBookingCriteria searchKey(String searchKey) {
    this.searchKey = searchKey;
    return this;
  }

   /**
   * Get searchKey
   * @return searchKey
  **/
  @Schema(required = true, description = "")
  public String getSearchKey() {
    return searchKey;
  }

  public void setSearchKey(String searchKey) {
    this.searchKey = searchKey;
  }

  public HotelBookingCriteria clientReference(String clientReference) {
    this.clientReference = clientReference;
    return this;
  }

   /**
   * Get clientReference
   * @return clientReference
  **/
  @Schema(required = true, description = "")
  public String getClientReference() {
    return clientReference;
  }

  public void setClientReference(String clientReference) {
    this.clientReference = clientReference;
  }

  public HotelBookingCriteria bookingKey(String bookingKey) {
    this.bookingKey = bookingKey;
    return this;
  }

   /**
   * Get bookingKey
   * @return bookingKey
  **/
  @Schema(required = true, description = "")
  public String getBookingKey() {
    return bookingKey;
  }

  public void setBookingKey(String bookingKey) {
    this.bookingKey = bookingKey;
  }

  public HotelBookingCriteria hotelKey(String hotelKey) {
    this.hotelKey = hotelKey;
    return this;
  }

   /**
   * Get hotelKey
   * @return hotelKey
  **/
  @Schema(required = true, description = "")
  public String getHotelKey() {
    return hotelKey;
  }

  public void setHotelKey(String hotelKey) {
    this.hotelKey = hotelKey;
  }

  public HotelBookingCriteria totalNet(Double totalNet) {
    this.totalNet = totalNet;
    return this;
  }

   /**
   * Get totalNet
   * minimum: 0
   * @return totalNet
  **/
  @Schema(description = "")
  public Double getTotalNet() {
    return totalNet;
  }

  public void setTotalNet(Double totalNet) {
    this.totalNet = totalNet;
  }

  public HotelBookingCriteria currency(String currency) {
    this.currency = currency;
    return this;
  }

   /**
   * Get currency
   * @return currency
  **/
  @Schema(description = "")
  public String getCurrency() {
    return currency;
  }

  public void setCurrency(String currency) {
    this.currency = currency;
  }

  public HotelBookingCriteria culture(String culture) {
    this.culture = culture;
    return this;
  }

   /**
   * Get culture
   * @return culture
  **/
  @Schema(description = "")
  public String getCulture() {
    return culture;
  }

  public void setCulture(String culture) {
    this.culture = culture;
  }

  public HotelBookingCriteria stayDateRange(StayDateRange stayDateRange) {
    this.stayDateRange = stayDateRange;
    return this;
  }

   /**
   * Get stayDateRange
   * @return stayDateRange
  **/
  @Schema(description = "")
  public StayDateRange getStayDateRange() {
    return stayDateRange;
  }

  public void setStayDateRange(StayDateRange stayDateRange) {
    this.stayDateRange = stayDateRange;
  }

  public HotelBookingCriteria rooms(List<BookingRoom> rooms) {
    this.rooms = rooms;
    return this;
  }

  public HotelBookingCriteria addRoomsItem(BookingRoom roomsItem) {
    if (this.rooms == null) {
      this.rooms = new ArrayList<BookingRoom>();
    }
    this.rooms.add(roomsItem);
    return this;
  }

   /**
   * Get rooms
   * @return rooms
  **/
  @Schema(description = "")
  public List<BookingRoom> getRooms() {
    return rooms;
  }

  public void setRooms(List<BookingRoom> rooms) {
    this.rooms = rooms;
  }

  public HotelBookingCriteria taxDetails(TaxDetails taxDetails) {
    this.taxDetails = taxDetails;
    return this;
  }

   /**
   * Get taxDetails
   * @return taxDetails
  **/
  @Schema(description = "")
  public TaxDetails getTaxDetails() {
    return taxDetails;
  }

  public void setTaxDetails(TaxDetails taxDetails) {
    this.taxDetails = taxDetails;
  }

  public HotelBookingCriteria paymentDetails(HotelPaymentDetails paymentDetails) {
    this.paymentDetails = paymentDetails;
    return this;
  }

   /**
   * Get paymentDetails
   * @return paymentDetails
  **/
  @Schema(description = "")
  public HotelPaymentDetails getPaymentDetails() {
    return paymentDetails;
  }

  public void setPaymentDetails(HotelPaymentDetails paymentDetails) {
    this.paymentDetails = paymentDetails;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HotelBookingCriteria hotelBookingCriteria = (HotelBookingCriteria) o;
    return Objects.equals(this.searchKey, hotelBookingCriteria.searchKey) &&
        Objects.equals(this.clientReference, hotelBookingCriteria.clientReference) &&
        Objects.equals(this.bookingKey, hotelBookingCriteria.bookingKey) &&
        Objects.equals(this.hotelKey, hotelBookingCriteria.hotelKey) &&
        Objects.equals(this.totalNet, hotelBookingCriteria.totalNet) &&
        Objects.equals(this.currency, hotelBookingCriteria.currency) &&
        Objects.equals(this.culture, hotelBookingCriteria.culture) &&
        Objects.equals(this.stayDateRange, hotelBookingCriteria.stayDateRange) &&
        Objects.equals(this.rooms, hotelBookingCriteria.rooms) &&
        Objects.equals(this.taxDetails, hotelBookingCriteria.taxDetails) &&
        Objects.equals(this.paymentDetails, hotelBookingCriteria.paymentDetails);
  }

  @Override
  public int hashCode() {
    return Objects.hash(searchKey, clientReference, bookingKey, hotelKey, totalNet, currency, culture, stayDateRange, rooms, taxDetails, paymentDetails);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HotelBookingCriteria {\n");
    
    sb.append("    searchKey: ").append(toIndentedString(searchKey)).append("\n");
    sb.append("    clientReference: ").append(toIndentedString(clientReference)).append("\n");
    sb.append("    bookingKey: ").append(toIndentedString(bookingKey)).append("\n");
    sb.append("    hotelKey: ").append(toIndentedString(hotelKey)).append("\n");
    sb.append("    totalNet: ").append(toIndentedString(totalNet)).append("\n");
    sb.append("    currency: ").append(toIndentedString(currency)).append("\n");
    sb.append("    culture: ").append(toIndentedString(culture)).append("\n");
    sb.append("    stayDateRange: ").append(toIndentedString(stayDateRange)).append("\n");
    sb.append("    rooms: ").append(toIndentedString(rooms)).append("\n");
    sb.append("    taxDetails: ").append(toIndentedString(taxDetails)).append("\n");
    sb.append("    paymentDetails: ").append(toIndentedString(paymentDetails)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
