/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Address;
import io.swagger.client.model.Air;
import io.swagger.client.model.AirBookCriteria;
import io.swagger.client.model.AirCriteria;
import io.swagger.client.model.AirIdentityDocument;
import io.swagger.client.model.AirPassenger;
import io.swagger.client.model.AirPaymentDetails;
import io.swagger.client.model.AirProvBookCriteria;
import io.swagger.client.model.Contact;
import io.swagger.client.model.ContactsProvided;
import io.swagger.client.model.CustomerInfo;
import io.swagger.client.model.FlightSegment;
import io.swagger.client.model.Journey;
import io.swagger.client.model.Passenger;
import io.swagger.client.model.PassengerInfo;
import io.swagger.client.model.Phone;
import io.swagger.client.model.PostalAddress;
import io.swagger.client.model.ResponsePackAir;
import io.swagger.client.model.ResponsePackAirBooking;
import io.swagger.client.model.ResponsePackLoginResponse;
import io.swagger.client.model.ResponseParameters;
import io.swagger.client.model.UserLoginDetails;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Ignore;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * API tests for AirSearchServiceApi
 */
@Ignore
public class AirSearchServiceApiTest {
    private static Logger LOGGER = null;
    static {
        System.setProperty("java.util.logging.SimpleFormatter.format",
                "[%1$tF %1$tT] [%4$-7s] %5$s %n");
        LOGGER = Logger.getLogger(AirSearchServiceApiTest.class.getName());
    }
    private static final String X_API_KEY = "<api-key>";
    private static String conversationId = UUID.randomUUID().toString();
    private static String sessionId;
    private static String offerId;
    private static String bookedOfferId;
    private static double totalFare;
    private static List<Journey> journey;
    private static Air selectedOffer;
    private static String departureDate="2023-06-30";
    private static String arrivalDate="2023-06-30";
    private static List<Air> airSearchOfferList=new ArrayList<Air>();
    private static boolean isSearchSuccess=false;
    private static boolean isProvBookSuccess=false;
    private static boolean isBookSuccess=false;
    private static List<AirPassenger> passengers=new ArrayList<>();


    private final ReservationServiceApi api = new  ReservationServiceApi();
    @BeforeClass
    public static void setup() throws ApiException, io.swagger.client.ApiException {
        UserLoginDetails body = new UserLoginDetails();
        body.setUserName("UserName"); //Your user name
        body.setPassword("Password"); //Your password
        body.setCompanyCode("CompanyCode"); //Your company code

        ResponsePackLoginResponse response = (new AuthServiceApi()).loginUser(body, conversationId, X_API_KEY);

        sessionId = response.getData().get(0).getSessionId();
        LOGGER.log(Level.INFO, "-------------------Login-----------------------");
        LOGGER.log(Level.INFO, "sessionId: {0}", new Object[]{sessionId });
        LOGGER.log(Level.INFO, "------------------------------------------");

        AirPassenger pax=new AirPassenger();
        setPax(pax);
        passengers.add(pax);

    }
    public static void setPax(AirPassenger pax){
        pax.setPassengerKey("SH4H23B-1");
        pax.setPtc("ADT");
        {
            PassengerInfo paxInfo = new PassengerInfo();
            paxInfo.setBirthDate("1991-12-15");
            paxInfo.setGender("M");
            paxInfo.setNameTitle("Mr");
            paxInfo.setGivenName("Anila");
            paxInfo.setMiddleName("Test");
            paxInfo.setSurname("Mishra");
            pax.setPassengerInfo(paxInfo);
        }
        {
            AirIdentityDocument idDoc=new AirIdentityDocument();
            idDoc.setIdDocumentNumber("12345gyhgha");
            idDoc.setIdType("PT");
            idDoc.setIssuingCountryCode("AE");
            idDoc.setResidenceCountryCode("AE");
            idDoc.setExpiryDate("2025-05-06");
            pax.setIdentityDocuments(Arrays.asList(idDoc));
        }
        {
            Contact contact=new Contact();
            PostalAddress poa=new PostalAddress();
            poa.setLabel("AddressAtDestination");
            List<String > street =new ArrayList<>();
            street.add("Beeches Apartment");
            street.add("200 Lampton Road");
            poa.setStreet(street );
            poa.setPostalCode("123456");
            poa.setCityName("DXB");
            poa.setCountryCode("AE");

            contact.setPostalAddress(poa);

            ContactsProvided cp=new ContactsProvided();
            cp.setEmailAddress( Arrays.asList("tarana@BA.COM"));
            Phone ph=new Phone();
            ph.setLabel("Origin");
            ph.setAreaCode(979);
            ph.setPhoneNumber("2087385301");
            cp.setPhone(Arrays.asList(ph));

            contact.setContactsProvide(Arrays.asList(cp));

            pax.setContact(contact);
        }
    }

    /**
     * Air search
     *
     * Get Air search response
     *
     * @throws Exception
     *          if the Api call fails
     */
//    @Test
//    @Order(1)
    public void performAirSearchRqTest() throws Exception {
        LOGGER.log(Level.INFO, "-------------------FLT SEARCH-----------------------");
        AirCriteria body = new AirCriteria();
        FlightSegment flightSegment=new FlightSegment();
        flightSegment.setDepartureAirportCode("DXB");
        flightSegment.setDepartureDate( departureDate);
        flightSegment.setArrivalAirportCode("LHR");
        flightSegment.setArrivalDate(arrivalDate);
        flightSegment.setCabinPreferences(Arrays.asList("5"));

        body.setFlightSegments(Arrays.asList(flightSegment));

        Passenger passenger = new Passenger();
        passenger.setId("1");
        passenger.setPtc("ADT");

        body.setPassengers(Arrays.asList(passenger));
        body.setFormOfPayment("CR");
        body.setTravelType("p");
        ResponseParameters resParam=new ResponseParameters();
        resParam.setShopResultPreference("OPTIMIZED");
        body.setResponseParameters(resParam);

        ResponsePackAir response = new AirSearchServiceApi().performAirSearchRq(body, sessionId, conversationId, X_API_KEY);
        if(response.getErrorDetails()==null) {

            airSearchOfferList=response.getData();

            //LOGGER.log(Level.INFO, "Selected Offers ->");
            for (Air res : response.getData()) {
                if("BA".equalsIgnoreCase(res.getJourney().get(0).getFlightSegments().get(0).getOperatingAirline())){
                    isSearchSuccess=true;
                    offerId = res.getOfferId();
                    journey=res.getJourney();
                    selectedOffer=res;
                    LOGGER.log(Level.INFO, "OfferID: {0}", new Object[]{res.getOfferId()});
                    break;
                }

//            LOGGER.log(Level.INFO, "Journies: ");
//            for(int i=0; i<res.getJourney().size(); i++){
//                LOGGER.log(Level.INFO, "Flight Key - {0}: {1}", new Object[]{ i, res.getJourney().get(i).getFlight().getFlightKey() });
//            }
            }
        }else{
            LOGGER.log(Level.INFO, "Error in FLT Search");
            LOGGER.log(Level.WARNING, response.getErrorDetails().toString());
        }
        LOGGER.log(Level.INFO, "------------------------------------------");


        // TODO: test validations
    }
    /**
     * Air fare rules
     *
     * Get Air fare rules
     *
     * @throws Exception
     *          if the Api call fails
     */
//    @Test
//    public void performFareRuleSearchRqTest() throws Exception {
//        LOGGER.log(Level.INFO, "AFRSF sessionId: {0}", new Object[]{sessionId });
//        AirFareRuleCriteria body = new  AirFareRuleCriteria();
//        body.setOfferId(offerId);
//        ResponsePackAirFareRuleResult response = api.performFareRuleSearchRq(body, sessionId, conversationId, X_API_KEY);
//        LOGGER.log(Level.INFO, "Fare Rules ->");
//        LOGGER.log(Level.INFO, response.getData().toString());
//        LOGGER.log(Level.INFO, "------------------------------------------");
//
//    }

    /**
     * Flight provisional book
     *
     * Flight provisional book
     *
     * @throws Exception
     *          if the Api call fails
     */
    //@Test
//    @Order(2)
    public void performAirProvisionalBookingTest() throws Exception ,io.swagger.client.ApiException{
        performAirSearchRqTest();
        LOGGER.log(Level.INFO, "-------------------FLT PROVBOOK-----------------------");
        if(isSearchSuccess) {
            AirProvBookCriteria body = new AirProvBookCriteria();
            body.setOfferId(offerId);

//            for (Air searchOffer : airSearchOfferList) {
//                body.setOfferId(searchOffer.getOfferId());
//                //body.setJourney(searchOffer.getJourney());
//            }
            Air searchOffer = selectedOffer;
            body.setJourney(searchOffer.getJourney());
            body.setPassengers(passengers);
            {
                AirPaymentDetails paymentDetails = new AirPaymentDetails();
                paymentDetails.setPaymentMode("CR");
                paymentDetails.setCardInfo("");

                Address address=new Address();
                address.setLabel("AddressAtDestination");
                List<String > street =new ArrayList<>();
                street.add("Beeches Apartment");
                street.add("200 Lampton Road");
                address.setStreet(street );
                address.setPostalCode("123456");
                address.setCityName("DXB");
                address.setCountryCode("AE");

                paymentDetails.setAddress(address);
                body.setPaymentDetails(paymentDetails);
            }
            ResponsePackAir responseProvbook = api.performAirProvisionalBooking(body, sessionId, conversationId, X_API_KEY);
            if(responseProvbook.getErrorDetails()==null) {
                isProvBookSuccess=true;
                LOGGER.log(Level.INFO, "bookedOfferId: {0}", new Object[]{responseProvbook.getData().get(0).getOfferId()});
                bookedOfferId=responseProvbook.getData().get(0).getOfferId();
                LOGGER.log(Level.INFO, "totalFare: {0}", new Object[]{responseProvbook.getData().get(0).getFare().getTotalFare()});
                totalFare=responseProvbook.getData().get(0).getFare().getTotalFare();
            }

        }else{
            LOGGER.log(Level.INFO, "ProvBook not executed due to Search flow not success");
        }
        LOGGER.log(Level.INFO, "------------------------------------------");

        // TODO: test validations
    }

    /**
     * Flight book
     *
     * Flight book
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void performAirBookingTest() throws Exception {
        performAirProvisionalBookingTest();
        LOGGER.log(Level.INFO, "-------------------FLT BOOK-----------------------");
        if(isProvBookSuccess){
            AirBookCriteria body = new AirBookCriteria();
            body.setOfferId(bookedOfferId);
            {
                CustomerInfo ci=new CustomerInfo();
                ci.setEmailAddress("test@test.com");
                body.setCustomerInfo(ci);
            }
            body.setPassengers(passengers);
            {
                AirPaymentDetails paymentDetails = new AirPaymentDetails();
                paymentDetails.setPaymentMode("CR");
                paymentDetails.setCardInfo("");

                Address address=new Address();
                address.setLabel("AddressAtDestination");
                List<String > street =new ArrayList<>();
                street.add("Beeches Apartment");
                street.add("200 Lampton Road");
                address.setStreet(street );
                address.setPostalCode("123456");
                address.setCityName("DXB");
                address.setCountryCode("AE");

                paymentDetails.setAddress(address);
                paymentDetails.setTransactionAmount(totalFare);
                body.setPaymentDetails(paymentDetails);
            }
            ResponsePackAirBooking responseBook = api.performAirBooking(body, sessionId, conversationId, X_API_KEY);
            if(responseBook.getErrorDetails()==null) {
                isBookSuccess=true;
                LOGGER.log(Level.INFO, "bookingReferenceId: {0}", new Object[]{responseBook.getData().get(0).getBookingReferenceId()});
                LOGGER.log(Level.INFO, "supplierLocator: {0}", new Object[]{responseBook.getData().get(0).getSupplierLocator()});
                LOGGER.log(Level.INFO, "ticketDocument: {0}", new Object[]{responseBook.getData().get(0).getTicketDocument()});
            }
        }else{
            LOGGER.log(Level.INFO, "Book not executed due to ProvBook flow not success");
        }
        LOGGER.log(Level.INFO, "------------------------------------------");




        // TODO: test validations
    }

}
