/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Car;
import io.swagger.client.model.CarCancellationPolicyCriteria;
import io.swagger.client.model.CarPassenger;
import io.swagger.client.model.CarPassengerCriteria;
import io.swagger.client.model.CarSearchCriteria;
import io.swagger.client.model.HotelHotelSearchApi;
import io.swagger.client.model.ResponsePackCar;
import io.swagger.client.model.ResponsePackCarCancellationPolicyResponse;
import io.swagger.client.model.ResponsePackLoginResponse;
import io.swagger.client.model.TaxDetails;
import io.swagger.client.model.UserLoginDetails;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Ignore;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * API tests for CarSearchServiceApi
 */
@Ignore
public class CarSearchServiceApiTest {

    private final CarSearchServiceApi api = new CarSearchServiceApi();
    private static Logger LOGGER = null;
    static {
        System.setProperty("java.util.logging.SimpleFormatter.format",
                "[%1$tF %1$tT] [%4$-7s] %5$s %n");
        LOGGER = Logger.getLogger(AirSearchServiceApiTest.class.getName());
    }
    private static final String X_API_KEY = "<api-key>";
    private static String conversationId = UUID.randomUUID().toString();
    private static String sessionId;
    @BeforeClass
    public static void setup() throws ApiException, io.swagger.client.ApiException {
        UserLoginDetails body = new UserLoginDetails();
        body.setUserName("UserName"); //Your user name
        body.setPassword("Password"); //Your password
        body.setCompanyCode("CompanyCode"); //Your company code

        ResponsePackLoginResponse response = (new AuthServiceApi()).loginUser(body, conversationId, X_API_KEY);

        sessionId = response.getData().get(0).getSessionId();
        LOGGER.log(Level.INFO, "-------------------Login-----------------------");
        LOGGER.log(Level.INFO, "sessionId: {0}", new Object[]{sessionId });
        LOGGER.log(Level.INFO, "------------------------------------------");

    }

    /**
     * Car Book
     *
     * Car Book
     *
     * @throws Exception
     *          if the Api call fails
     */
//    @Test
//    public void getCancellationPolicyTest() throws Exception {
//        CarCancellationPolicyCriteria body = null;
//        String sessionId = null;
//        String conversationId = null;
//        String X_API_KEY = null;
//        ResponsePackCarCancellationPolicyResponse response = api.getCancellationPolicy(body, sessionId, conversationId, X_API_KEY);
//
//        // TODO: test validations
//    }
    /**
     * Car search
     *
     * Car Search
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void performCarSearchTest() throws Exception {
        LOGGER.log(Level.INFO, "-------------------CAR SEARCH-----------------------");
        CarSearchCriteria body = new CarSearchCriteria();
        body.setPickupTime("10:00");
        body.setPickupDate("2023-07-26");
        body.setPickupLocationCode("1530");
        body.setPickupLocationName("Dubai International Airport Terminal 3,Airport Road D89 Al Garhoud, Dubai International Airport Terminal 3, United Arab Emirates");
        body.setPickupCountryCode("AE");
        body.setPickupCityName("Dubai International Airport Terminal 3");

        body.setDropOffDate( "2023-07-27");
        body.setDropOffTime("20:00");
        body.setDropOffLocationCode("1530");
        body.setDropOffLocationName("Dubai International Airport Terminal 3,Airport Road D89 Al Garhoud, Dubai International Airport Terminal 3, United Arab Emirates");
        body.setDropOffCountryCode("AE");
        body.setDropOffCityName("Dubai International Airport Terminal 3");

        CarPassengerCriteria passenger=new CarPassengerCriteria();
        passenger.setAdult(1);
        passenger.setChild(2);
        passenger.setChildAge(Arrays.asList(15,4));
        body.setPassengers(passenger);

        body.setDriverAge(40);

        TaxDetails taxDetails=new TaxDetails();
        taxDetails.setTaxName("GST");
        taxDetails.setRegNo("08AADCB2923M1ZL");
        taxDetails.setCompanyName("BAJAJ AUTO LIMITED");
        taxDetails.setEmailAddress("balairline@bajajauto.co.in");
        taxDetails.setPhoneNo("9928000021");
        taxDetails.setAddress("A-47 VRINDAVAN VIHAR KINGS ROAD Jaipur AJMER ROAD Rajasthan 302019");
        body.setTaxDetails(taxDetails);

        body.setTaxDetails(taxDetails);
        ResponsePackCar response = api.performCarSearch(body, sessionId, conversationId, X_API_KEY);
        if(response.getErrorDetails()==null) {
            for (Car res : response.getData()) {
                LOGGER.log(Level.INFO, "offerId: {0}", new Object[]{res.getOfferId()});
            }
        }else{
            LOGGER.log(Level.INFO, "Error in Car Search");
            LOGGER.log(Level.WARNING, response.getErrorDetails().toString());
        }
        LOGGER.log(Level.INFO, "------------------------------------------");
        // TODO: test validations
    }
}
