/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.Air;
import io.swagger.client.model.AirPassenger;
import io.swagger.client.model.BaseHotelCriteria;
import io.swagger.client.model.Filters;
import io.swagger.client.model.Hotel;
import io.swagger.client.model.HotelCancellationPolicyCriteria;
import io.swagger.client.model.HotelHotelSearchApi;
import io.swagger.client.model.HotelSearchCriteria;
import io.swagger.client.model.ResponsePackCancellationPolicy;
import io.swagger.client.model.ResponsePackHotel;
import io.swagger.client.model.ResponsePackHotelDetails;
import io.swagger.client.model.ResponsePackLoginResponse;
import io.swagger.client.model.Room;
import io.swagger.client.model.RoomRq;
import io.swagger.client.model.TaxDetails;
import io.swagger.client.model.UserLoginDetails;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Ignore;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * API tests for HotelSearchServiceApi
 */
@Ignore
public class HotelSearchServiceApiTest {
    private static Logger LOGGER = null;
    static {
        System.setProperty("java.util.logging.SimpleFormatter.format",
                "[%1$tF %1$tT] [%4$-7s] %5$s %n");
        LOGGER = Logger.getLogger(AirSearchServiceApiTest.class.getName());
    }

    private final HotelSearchServiceApi api = new HotelSearchServiceApi();
    private static final String X_API_KEY = "<api-key>";
    private static String conversationId = UUID.randomUUID().toString();
    private static String sessionId;
    private  String searchKey;
    private  String hotelKey;
    @BeforeClass
    public static void setup() throws ApiException, io.swagger.client.ApiException {
        UserLoginDetails body = new UserLoginDetails();
        body.setUserName("UserName"); //Your user name
        body.setPassword("Password"); //Your password
        body.setCompanyCode("CompanyCode"); //Your company code

        ResponsePackLoginResponse response = (new AuthServiceApi()).loginUser(body, conversationId, X_API_KEY);

        sessionId = response.getData().get(0).getSessionId();
        LOGGER.log(Level.INFO, "-------------------Login-----------------------");
        LOGGER.log(Level.INFO, "sessionId: {0}", new Object[]{sessionId });
        LOGGER.log(Level.INFO, "------------------------------------------");

    }

    /**
     * Get Hotel Cancellation Policies
     *
     * Get Hotel Cancellation Policies
     *
     * @throws Exception
     *          if the Api call fails
     */
//    @Test
//    public void performCancellationPoliciesRqTest() throws Exception {
//        HotelCancellationPolicyCriteria body = null;
//        String sessionId = null;
//        String conversationId = null;
//        String X_API_KEY = null;
//        ResponsePackCancellationPolicy response = api.performCancellationPoliciesRq(body, sessionId, conversationId, X_API_KEY);
//
//        // TODO: test validations
//    }
    /**
     * Hotel Detail Search
     *
     * Hotel detail search
     *
     * @throws Exception
     *          if the Api call fails
     */
//    @Test
//    public void performHotelDetailSearchRqTest() throws Exception {
//        BaseHotelCriteria body = null;
//        String sessionId = null;
//        String conversationId = null;
//        String X_API_KEY = null;
//        ResponsePackHotelDetails response = api.performHotelDetailSearchRq(body, sessionId, conversationId, X_API_KEY);
//
//        // TODO: test validations
//    }
    /**
     * Hotel Search
     *
     * Hotel search
     *
     * @throws Exception
     *          if the Api call fails
     */
    //@Test
    public void performHotelSearchRqTest() throws Exception {
        LOGGER.log(Level.INFO, "-------------------HOTEL SEARCH-----------------------");
        HotelSearchCriteria body =new HotelSearchCriteria();
        body.setCountry("India");
        body.setCity("Mumbai");
        body.setCheckIn("2023-06-20");
        body.setCheckOut("2023-06-21");

        RoomRq roomRq =new RoomRq();
        roomRq.setAdult(1);
        roomRq.setChild(0);
        roomRq.setRoomIndex(1);

        body.setRooms(Arrays.asList(roomRq));

        body.setTravelerCountryOfResidence("India,In");
        body.setTravelerNationality("India,In");
        body.setCulture("en");

        Filters filters=new Filters();
        filters.setCurrency("INR");
        filters.setMinStarRating(0);
        filters.setAvailableHotelsOnly(true);
        filters.setPayAtHotelRates(false);
        body.setFilters(filters);

        TaxDetails taxDetails=new TaxDetails();
        taxDetails.setTaxName("GST");
        taxDetails.setRegNo("08AADCB2923M1ZL");
        taxDetails.setCompanyName("BAJAJ AUTO LIMITED");
        taxDetails.setEmailAddress("balairline@bajajauto.co.in");
        taxDetails.setPhoneNo("9928000021");
        taxDetails.setAddress("A-47 VRINDAVAN VIHAR KINGS ROAD Jaipur AJMER ROAD Rajasthan 302019");
        body.setTaxDetails(taxDetails);
        ResponsePackHotel response = api.performHotelSearchRq(body, sessionId, conversationId, X_API_KEY);
        if(response.getErrorDetails()==null) {
            searchKey=response.getCommonData().getSearchKey();
            for (HotelHotelSearchApi res : response.getData()) {
                LOGGER.log(Level.INFO, "hotelKey: {0}", new Object[]{res.getHotelKey()});
                if(hotelKey==null){
                    hotelKey=res.getHotelKey();
                }
            }
        }else{
            LOGGER.log(Level.INFO, "Error in Hotel Search");
            LOGGER.log(Level.WARNING, response.getErrorDetails().toString());
        }
        LOGGER.log(Level.INFO, "------------------------------------------");

        // TODO: test validations
    }
    /**
     * Hotel Search Get More Rooms
     *
     * Hotel search get more rooms
     *
     * @throws Exception
     *          if the Api call fails
     */
    @Test
    public void performMoreRoomRqTest() throws Exception {
        performHotelSearchRqTest();
        LOGGER.log(Level.INFO, "-------------------HOTEL MORE ROOMS SEARCH-----------------------");
        BaseHotelCriteria body = new BaseHotelCriteria();
        body.setSearchKey(searchKey);
        body.setHotelKey(hotelKey);
        body.setCulture("en");
        ResponsePackHotel response = api.performMoreRoomRq(body, sessionId, conversationId, X_API_KEY);
        if(response.getErrorDetails()==null) {
            for (HotelHotelSearchApi res : response.getData()) {
                LOGGER.log(Level.INFO, "--->>> hotelKey: {0}", new Object[]{res.getHotelKey()});
                for(Room room:res.getRooms()){
                    LOGGER.log(Level.INFO, "roomId: {0}", new Object[]{room.getRoomId()});
                }
                LOGGER.log(Level.INFO, "--->>>");
            }
        }else{
            LOGGER.log(Level.INFO, "Error in Hotel More Rooms Search");
            LOGGER.log(Level.WARNING, response.getErrorDetails().toString());
        }
        // TODO: test validations
        LOGGER.log(Level.INFO, "------------------------------------------");
    }
}
