/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.AirCriteria;
import io.swagger.client.model.AirFareRuleCriteria;
import io.swagger.client.model.MoreFaresCriteria;
import io.swagger.client.model.ResponsePackAir;
import io.swagger.client.model.ResponsePackAirFareRuleResult;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AirSearchServiceApi {
    private ApiClient apiClient;

    public AirSearchServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AirSearchServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for performAirSearchRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performAirSearchRqCall(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/flight/search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performAirSearchRqValidateBeforeCall(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performAirSearchRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performAirSearchRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performAirSearchRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performAirSearchRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performAirSearchRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Air search
     * Get Air search response
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performAirSearchRq(AirCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performAirSearchRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Air search
     * Get Air search response
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performAirSearchRqWithHttpInfo(AirCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performAirSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Air search (asynchronously)
     * Get Air search response
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performAirSearchRqAsync(AirCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performAirSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performFareRuleSearchRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performFareRuleSearchRqCall(AirFareRuleCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/flight/fare-rule-search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performFareRuleSearchRqValidateBeforeCall(AirFareRuleCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performFareRuleSearchRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performFareRuleSearchRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performFareRuleSearchRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performFareRuleSearchRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performFareRuleSearchRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Air fare rules
     * Get Air fare rules
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAirFareRuleResult
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAirFareRuleResult performFareRuleSearchRq(AirFareRuleCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAirFareRuleResult> resp = performFareRuleSearchRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Air fare rules
     * Get Air fare rules
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAirFareRuleResult&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAirFareRuleResult> performFareRuleSearchRqWithHttpInfo(AirFareRuleCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performFareRuleSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAirFareRuleResult>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Air fare rules (asynchronously)
     * Get Air fare rules
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performFareRuleSearchRqAsync(AirFareRuleCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAirFareRuleResult> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performFareRuleSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAirFareRuleResult>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performMoreFaresSearchRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performMoreFaresSearchRqCall(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/flight/more-fares";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performMoreFaresSearchRqValidateBeforeCall(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performMoreFaresSearchRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performMoreFaresSearchRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performMoreFaresSearchRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performMoreFaresSearchRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performMoreFaresSearchRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Air more fare search
     * Get Air more fares
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackAir
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackAir performMoreFaresSearchRq(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackAir> resp = performMoreFaresSearchRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Air more fare search
     * Get Air more fares
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackAir&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackAir> performMoreFaresSearchRqWithHttpInfo(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performMoreFaresSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Air more fare search (asynchronously)
     * Get Air more fares
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performMoreFaresSearchRqAsync(MoreFaresCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackAir> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performMoreFaresSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackAir>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
