/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ResponsePackLoginResponse;
import io.swagger.client.model.ResponsePackString;
import io.swagger.client.model.UserLoginDetails;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AuthServiceApi {
    private ApiClient apiClient;

    public AuthServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AuthServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for loginUser
     * @param body  (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call loginUserCall(UserLoginDetails body, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/auth/login";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call loginUserValidateBeforeCall(UserLoginDetails body, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling loginUser(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling loginUser(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling loginUser(Async)");
        }
        
        com.squareup.okhttp.Call call = loginUserCall(body, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Login user
     * Get session id by loggin in
     * @param body  (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackLoginResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackLoginResponse loginUser(UserLoginDetails body, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackLoginResponse> resp = loginUserWithHttpInfo(body, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Login user
     * Get session id by loggin in
     * @param body  (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackLoginResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackLoginResponse> loginUserWithHttpInfo(UserLoginDetails body, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = loginUserValidateBeforeCall(body, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackLoginResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Login user (asynchronously)
     * Get session id by loggin in
     * @param body  (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call loginUserAsync(UserLoginDetails body, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackLoginResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = loginUserValidateBeforeCall(body, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackLoginResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for logoutUser
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call logoutUserCall(String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/v1/auth/logout";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call logoutUserValidateBeforeCall(String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling logoutUser(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling logoutUser(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling logoutUser(Async)");
        }
        
        com.squareup.okhttp.Call call = logoutUserCall(sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Logout use
     * Logout from the session
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackString
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackString logoutUser(String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackString> resp = logoutUserWithHttpInfo(sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Logout use
     * Logout from the session
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackString&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackString> logoutUserWithHttpInfo(String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = logoutUserValidateBeforeCall(sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackString>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Logout use (asynchronously)
     * Logout from the session
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call logoutUserAsync(String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackString> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = logoutUserValidateBeforeCall(sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackString>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
