/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.BaseHotelCriteria;
import io.swagger.client.model.HotelCancellationPolicyCriteria;
import io.swagger.client.model.HotelSearchCriteria;
import io.swagger.client.model.ResponsePackCancellationPolicy;
import io.swagger.client.model.ResponsePackHotel;
import io.swagger.client.model.ResponsePackHotelDetails;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HotelSearchServiceApi {
    private ApiClient apiClient;

    public HotelSearchServiceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HotelSearchServiceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for performCancellationPoliciesRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performCancellationPoliciesRqCall(HotelCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/hotel/cancellation-policy";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performCancellationPoliciesRqValidateBeforeCall(HotelCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performCancellationPoliciesRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performCancellationPoliciesRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performCancellationPoliciesRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performCancellationPoliciesRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performCancellationPoliciesRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Hotel Cancellation Policies
     * Get Hotel Cancellation Policies
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackCancellationPolicy
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackCancellationPolicy performCancellationPoliciesRq(HotelCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackCancellationPolicy> resp = performCancellationPoliciesRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Get Hotel Cancellation Policies
     * Get Hotel Cancellation Policies
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackCancellationPolicy&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackCancellationPolicy> performCancellationPoliciesRqWithHttpInfo(HotelCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performCancellationPoliciesRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackCancellationPolicy>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Hotel Cancellation Policies (asynchronously)
     * Get Hotel Cancellation Policies
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performCancellationPoliciesRqAsync(HotelCancellationPolicyCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackCancellationPolicy> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performCancellationPoliciesRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackCancellationPolicy>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelDetailSearchRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelDetailSearchRqCall(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/hotel/details";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelDetailSearchRqValidateBeforeCall(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelDetailSearchRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelDetailSearchRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelDetailSearchRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelDetailSearchRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelDetailSearchRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Detail Search
     * Hotel detail search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotelDetails
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotelDetails performHotelDetailSearchRq(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotelDetails> resp = performHotelDetailSearchRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Detail Search
     * Hotel detail search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotelDetails&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotelDetails> performHotelDetailSearchRqWithHttpInfo(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelDetailSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotelDetails>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Detail Search (asynchronously)
     * Hotel detail search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelDetailSearchRqAsync(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotelDetails> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelDetailSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotelDetails>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performHotelSearchRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performHotelSearchRqCall(HotelSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/hotel/search";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performHotelSearchRqValidateBeforeCall(HotelSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performHotelSearchRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performHotelSearchRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performHotelSearchRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performHotelSearchRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performHotelSearchRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Search
     * Hotel search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotel
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotel performHotelSearchRq(HotelSearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotel> resp = performHotelSearchRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Search
     * Hotel search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotel&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotel> performHotelSearchRqWithHttpInfo(HotelSearchCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performHotelSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotel>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Search (asynchronously)
     * Hotel search
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performHotelSearchRqAsync(HotelSearchCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotel> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performHotelSearchRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotel>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for performMoreRoomRq
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call performMoreRoomRqCall(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/v1/hotel/more-rooms";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (sessionId != null)
        localVarHeaderParams.put("sessionId", apiClient.parameterToString(sessionId));
        if (conversationId != null)
        localVarHeaderParams.put("conversationId", apiClient.parameterToString(conversationId));
        if (X_API_KEY != null)
        localVarHeaderParams.put("X-API-KEY", apiClient.parameterToString(X_API_KEY));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call performMoreRoomRqValidateBeforeCall(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling performMoreRoomRq(Async)");
        }
        // verify the required parameter 'sessionId' is set
        if (sessionId == null) {
            throw new ApiException("Missing the required parameter 'sessionId' when calling performMoreRoomRq(Async)");
        }
        // verify the required parameter 'conversationId' is set
        if (conversationId == null) {
            throw new ApiException("Missing the required parameter 'conversationId' when calling performMoreRoomRq(Async)");
        }
        // verify the required parameter 'X_API_KEY' is set
        if (X_API_KEY == null) {
            throw new ApiException("Missing the required parameter 'X_API_KEY' when calling performMoreRoomRq(Async)");
        }
        
        com.squareup.okhttp.Call call = performMoreRoomRqCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Hotel Search Get More Rooms
     * Hotel search get more rooms
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ResponsePackHotel
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ResponsePackHotel performMoreRoomRq(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        ApiResponse<ResponsePackHotel> resp = performMoreRoomRqWithHttpInfo(body, sessionId, conversationId, X_API_KEY);
        return resp.getData();
    }

    /**
     * Hotel Search Get More Rooms
     * Hotel search get more rooms
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @return ApiResponse&lt;ResponsePackHotel&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ResponsePackHotel> performMoreRoomRqWithHttpInfo(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY) throws ApiException {
        com.squareup.okhttp.Call call = performMoreRoomRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, null, null);
        Type localVarReturnType = new TypeToken<ResponsePackHotel>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Hotel Search Get More Rooms (asynchronously)
     * Hotel search get more rooms
     * @param body  (required)
     * @param sessionId Session ID (required)
     * @param conversationId Conversation ID (required)
     * @param X_API_KEY API access key (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call performMoreRoomRqAsync(BaseHotelCriteria body, String sessionId, String conversationId, String X_API_KEY, final ApiCallback<ResponsePackHotel> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = performMoreRoomRqValidateBeforeCall(body, sessionId, conversationId, X_API_KEY, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ResponsePackHotel>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
