/*
 * Travel Search API
 * API for perform travel booking
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ApiErrorDetails;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.threeten.bp.OffsetDateTime;
/**
 * ApiErrorDetails
 */


public class ApiErrorDetails {
  @SerializedName("code")
  private String code = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    INTERNAL_ERROR("INTERNAL_ERROR"),
    USER_ERROR("USER_ERROR"),
    INFORMATIONAL("INFORMATIONAL");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TypeEnum fromValue(String input) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("documentationUrl")
  private String documentationUrl = null;

  @SerializedName("source")
  private Map<String, String> source = null;

  @SerializedName("path")
  private String path = null;

  @SerializedName("timestamp")
  private OffsetDateTime timestamp = null;

  @SerializedName("documentationUrlPath")
  private ApiErrorDetails documentationUrlPath = null;

  public ApiErrorDetails code(String code) {
    this.code = code;
    return this;
  }

   /**
   * Get code
   * @return code
  **/
  @Schema(description = "")
  public String getCode() {
    return code;
  }

  public void setCode(String code) {
    this.code = code;
  }

  public ApiErrorDetails type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @Schema(description = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public ApiErrorDetails title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @Schema(description = "")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ApiErrorDetails message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Get message
   * @return message
  **/
  @Schema(description = "")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public ApiErrorDetails documentationUrl(String documentationUrl) {
    this.documentationUrl = documentationUrl;
    return this;
  }

   /**
   * Get documentationUrl
   * @return documentationUrl
  **/
  @Schema(description = "")
  public String getDocumentationUrl() {
    return documentationUrl;
  }

  public void setDocumentationUrl(String documentationUrl) {
    this.documentationUrl = documentationUrl;
  }

  public ApiErrorDetails source(Map<String, String> source) {
    this.source = source;
    return this;
  }

  public ApiErrorDetails putSourceItem(String key, String sourceItem) {
    if (this.source == null) {
      this.source = new HashMap<String, String>();
    }
    this.source.put(key, sourceItem);
    return this;
  }

   /**
   * Get source
   * @return source
  **/
  @Schema(description = "")
  public Map<String, String> getSource() {
    return source;
  }

  public void setSource(Map<String, String> source) {
    this.source = source;
  }

  public ApiErrorDetails path(String path) {
    this.path = path;
    return this;
  }

   /**
   * Get path
   * @return path
  **/
  @Schema(description = "")
  public String getPath() {
    return path;
  }

  public void setPath(String path) {
    this.path = path;
  }

  public ApiErrorDetails timestamp(OffsetDateTime timestamp) {
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @Schema(description = "")
  public OffsetDateTime getTimestamp() {
    return timestamp;
  }

  public void setTimestamp(OffsetDateTime timestamp) {
    this.timestamp = timestamp;
  }

  public ApiErrorDetails documentationUrlPath(ApiErrorDetails documentationUrlPath) {
    this.documentationUrlPath = documentationUrlPath;
    return this;
  }

   /**
   * Get documentationUrlPath
   * @return documentationUrlPath
  **/
  @Schema(description = "")
  public ApiErrorDetails getDocumentationUrlPath() {
    return documentationUrlPath;
  }

  public void setDocumentationUrlPath(ApiErrorDetails documentationUrlPath) {
    this.documentationUrlPath = documentationUrlPath;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiErrorDetails apiErrorDetails = (ApiErrorDetails) o;
    return Objects.equals(this.code, apiErrorDetails.code) &&
        Objects.equals(this.type, apiErrorDetails.type) &&
        Objects.equals(this.title, apiErrorDetails.title) &&
        Objects.equals(this.message, apiErrorDetails.message) &&
        Objects.equals(this.documentationUrl, apiErrorDetails.documentationUrl) &&
        Objects.equals(this.source, apiErrorDetails.source) &&
        Objects.equals(this.path, apiErrorDetails.path) &&
        Objects.equals(this.timestamp, apiErrorDetails.timestamp) &&
        Objects.equals(this.documentationUrlPath, apiErrorDetails.documentationUrlPath);
  }

  @Override
  public int hashCode() {
    return Objects.hash(code, type, title, message, documentationUrl, source, path, timestamp, documentationUrlPath);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiErrorDetails {\n");
    
    sb.append("    code: ").append(toIndentedString(code)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    documentationUrl: ").append(toIndentedString(documentationUrl)).append("\n");
    sb.append("    source: ").append(toIndentedString(source)).append("\n");
    sb.append("    path: ").append(toIndentedString(path)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("    documentationUrlPath: ").append(toIndentedString(documentationUrlPath)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
